//----------------------------------------------------------------------------
//  Project WmPlayer
//  Solidyne SRL
//  (C) 2008 owlnext comunity
//
//  SUBSYSTEM:    WmPlayer Application
//  FILE:         wmplyrap.cpp
//  AUTHOR:       Sebastian Ledesma
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TWmPlayerApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <classlib/cmdline.h>
#include <winsys/registry.h>
#include <stdio.h>

#include <owl/appdict.h>

#include "wmplyrap.h"
#include "wmplyrdc.h"                        // Definition of client class.


//{{TWmPlayerApp Implementation}}
DEFINE_APP_DICTIONARY(AppDictionary);
//TAppDictionary AppDictionary;

REGISTRATION_FORMAT_BUFFER(128)    // create buffer for expanding macros
BEGIN_REGISTRATION(AppReg)
  //REGDATA(clsid, "{9B0BBE60-B6BD-101B-B3FF-86C8A0834EDE}")
  REGDATA(clsid, "{3B67CA3E-8189-40DE-B68E-C373910D6D1F}")
  REGDATA(description, "Media Player Container")
END_REGISTRATION

static TPointer<TOcRegistrar> Registrar;

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TWmPlayerApp, TApplication)
//{{TWmPlayerAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TWmPlayerAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TWmPlayerApp
//
TWmPlayerApp::TWmPlayerApp() : TApplication(::AppReg["description"])
{

  // INSERT>> Your constructor code here.
}


TWmPlayerApp::~TWmPlayerApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~
// Application intialization.
//
void TWmPlayerApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

/*  TOleFrame* frame = new TOleFrame(GetName(), 0, false);
  // Override the default window style for the main window.
  //
  frame->ModifyStyle(WS_THICKFRAME, WS_BORDER|WS_CAPTION|WS_CLIPCHILDREN|
                                    WS_MINIMIZEBOX|WS_SYSMENU|WS_VISIBLE);  */


  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);

}


//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~
// Application instance initialization.
//
void TWmPlayerApp::InitInstance()
{
  TApplication::InitInstance();

//  ProcessCmdLine(lpCmdLine);
  GetMainWindow()->SetClientWindow(new TWmPlayerDlgClient(0));
}


TUnknown* TWmPlayerApp::CreateOleObject(uint32 options, TRegLink* link){
//A implementar
return 0;
}

/*
//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~
// Process command line parameters.
//
void TWmPlayerApp::ProcessCmdLine(char * CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~
// Register application info.
//
void TWmPlayerApp::RegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "WmPlayer.Application\\DefaultIcon").SetDefValue(0, REG_SZ, buffer, strlen(buffer));
  strcat(buffer, ",1");
}


//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~
// Unregister application info.
//
void TWmPlayerApp::UnRegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "WmPlayer.Application").DeleteKey("DefaultIcon");
  TRegKey(TRegKey::ClassesRoot, "WmPlayer.Document.1").DeleteKey("DefaultIcon");

  TRegKey::ClassesRoot.DeleteKey("WmPlayer.Application");
} */



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TOleFrame( title, clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
  TRect  r;
  GetWindowRect(r);

  r.bottom += 30;
  SetWindowPos(0, r, SWP_NOZORDER | SWP_NOMOVE);

  // INSERT>> Your code here.

}


//--------------------------------------------------------
// TWmPlayerApp
// ~~~~~~~~~~~
// Menu Help About WmPlayer command
//
void TWmPlayerApp::CmHelpAbout()
{
}



int OwlMain(int , char* []) {

/*  TWmPlayerApp   app;
  return app.Run();*/

 // create the registrar object
  ::Registrar = new TOcRegistrar(::AppReg, TOleFactory<TWmPlayerApp>(), TApplication::GetCmdLine());
  return ::Registrar->Run();
}
