#include <ocf/pch.h>
#include <initguid.h>

#include <wtypes.h>   //needed before include ocf/defs.h SCODE definition
#include <scode.h>    //needed before include ocf/defs.h SCODE macros
#include <owl/defs.h> //needed before include ocf/defs.h, BI_PTR_0_32

#include "wmp.h"

void T_WMPOCXEventsProxy::_WMPOCXEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5001:
			OpenStateChange(Args[0]);
			break;

		case 5101:
			PlayStateChange(Args[0]);
			break;

		case 5102:
			AudioLanguageChange(Args[0]);
			break;

		case 5002:
			StatusChange();
			break;

		case 5301:
			ScriptCommand(Args[0], Args[1]);
			break;

		case 5403:
			NewStream();
			break;

		case 5401:
			Disconnect(Args[0]);
			break;

		case 5402:
			Buffering(Args[0]);
			break;

		case 5501:
			Error();
			break;

		case 5601:
			Warning(Args[0], Args[1], Args[2]);
			break;

		case 5201:
			EndOfStream(Args[0]);
			break;

		case 5202:
			PositionChange(Args[0], Args[1]);
			break;

		case 5203:
			MarkerHit(Args[0]);
			break;

		case 5204:
			DurationUnitChange(Args[0]);
			break;

		case 5701:
			CdromMediaChange(Args[0]);
			break;

		case 5801:
			PlaylistChange(Args[0], (WMPPlaylistChangeEventType)(int)Args[1]);
			break;

		case 5804:
			CurrentPlaylistChange((WMPPlaylistChangeEventType)(int)Args[0]);
			break;

		case 5805:
			CurrentPlaylistItemAvailable(Args[0]);
			break;

		case 5802:
			MediaChange(Args[0]);
			break;

		case 5803:
			CurrentMediaItemAvailable(Args[0]);
			break;

		case 5806:
			CurrentItemChange(Args[0]);
			break;

		case 5807:
			MediaCollectionChange();
			break;

		case 5808:
			MediaCollectionAttributeStringAdded(Args[0], Args[1]);
			break;

		case 5809:
			MediaCollectionAttributeStringRemoved(Args[0], Args[1]);
			break;

		case 5820:
			MediaCollectionAttributeStringChanged(Args[0], Args[1], Args[2]);
			break;

		case 5810:
			PlaylistCollectionChange();
			break;

		case 5811:
			PlaylistCollectionPlaylistAdded(Args[0]);
			break;

		case 5812:
			PlaylistCollectionPlaylistRemoved(Args[0]);
			break;

		case 5818:
			PlaylistCollectionPlaylistSetAsDeleted(Args[0], Args[1]);
			break;

		case 5819:
			ModeChange(Args[0], Args[1]);
			break;

		case 5821:
			MediaError(Args[0]);
			break;

		case 5823:
			OpenPlaylistSwitch(Args[0]);
			break;

		case 5822:
			DomainChange(Args[0]);
			break;

		case 6501:
			SwitchedToPlayerApplication();
			break;

		case 6502:
			SwitchedToControl();
			break;

		case 6503:
			PlayerDockedStateChange();
			break;

		case 6504:
			PlayerReconnect();
			break;

		case 6505:
			Click(Args[0], Args[1], Args[2], Args[3]);
			break;

		case 6506:
			DoubleClick(Args[0], Args[1], Args[2], Args[3]);
			break;

		case 6507:
			KeyDown(Args[0], Args[1]);
			break;

		case 6508:
			KeyPress(Args[0]);
			break;

		case 6509:
			KeyUp(Args[0], Args[1]);
			break;

		case 6510:
			MouseDown(Args[0], Args[1], Args[2], Args[3]);
			break;

		case 6511:
			MouseMove(Args[0], Args[1], Args[2], Args[3]);
			break;

		case 6512:
			MouseUp(Args[0], Args[1], Args[2], Args[3]);
			break;
	}
}

void T_WMPOCXEventsProxy::OpenStateChange(long /* NewState */)
{
}

void T_WMPOCXEventsProxy::PlayStateChange(long /* NewState */)
{
}

void T_WMPOCXEventsProxy::AudioLanguageChange(long /* LangID */)
{
}

void T_WMPOCXEventsProxy::StatusChange()
{
}

void T_WMPOCXEventsProxy::ScriptCommand(TAutoString /* scType */, TAutoString /* Param */)
{
}

void T_WMPOCXEventsProxy::NewStream()
{
}

void T_WMPOCXEventsProxy::Disconnect(long /* Result */)
{
}

void T_WMPOCXEventsProxy::Buffering(bool /* Start */)
{
}

void T_WMPOCXEventsProxy::Error()
{
}

void T_WMPOCXEventsProxy::Warning(long /* WarningType */, long /* Param */, TAutoString /* Description */)
{
}

void T_WMPOCXEventsProxy::EndOfStream(long /* Result */)
{
}

void T_WMPOCXEventsProxy::PositionChange(double /* oldPosition */, double /* newPosition */)
{
}

void T_WMPOCXEventsProxy::MarkerHit(long /* MarkerNum */)
{
}

void T_WMPOCXEventsProxy::DurationUnitChange(long /* NewDurationUnit */)
{
}

void T_WMPOCXEventsProxy::CdromMediaChange(long /* CdromNum */)
{
}

void T_WMPOCXEventsProxy::PlaylistChange(IDispatch* /* Playlist */, WMPPlaylistChangeEventType /* change */)
{
}

void T_WMPOCXEventsProxy::CurrentPlaylistChange(WMPPlaylistChangeEventType /* change */)
{
}

void T_WMPOCXEventsProxy::CurrentPlaylistItemAvailable(TAutoString /* bstrItemName */)
{
}

void T_WMPOCXEventsProxy::MediaChange(IDispatch* /* Item */)
{
}

void T_WMPOCXEventsProxy::CurrentMediaItemAvailable(TAutoString /* bstrItemName */)
{
}

void T_WMPOCXEventsProxy::CurrentItemChange(IDispatch* /* pdispMedia */)
{
}

void T_WMPOCXEventsProxy::MediaCollectionChange()
{
}

void T_WMPOCXEventsProxy::MediaCollectionAttributeStringAdded(TAutoString /* bstrAttribName */, TAutoString /* bstrAttribVal */)
{
}

void T_WMPOCXEventsProxy::MediaCollectionAttributeStringRemoved(TAutoString /* bstrAttribName */, TAutoString /* bstrAttribVal */)
{
}

void T_WMPOCXEventsProxy::MediaCollectionAttributeStringChanged(TAutoString /* bstrAttribName */, TAutoString /* bstrOldAttribVal */, TAutoString /* bstrNewAttribVal */)
{
}

void T_WMPOCXEventsProxy::PlaylistCollectionChange()
{
}

void T_WMPOCXEventsProxy::PlaylistCollectionPlaylistAdded(TAutoString /* bstrPlaylistName */)
{
}

void T_WMPOCXEventsProxy::PlaylistCollectionPlaylistRemoved(TAutoString /* bstrPlaylistName */)
{
}

void T_WMPOCXEventsProxy::PlaylistCollectionPlaylistSetAsDeleted(TAutoString /* bstrPlaylistName */, bool /* varfIsDeleted */)
{
}

void T_WMPOCXEventsProxy::ModeChange(TAutoString /* ModeName */, bool /* NewValue */)
{
}

void T_WMPOCXEventsProxy::MediaError(IDispatch* /* pMediaObject */)
{
}

void T_WMPOCXEventsProxy::OpenPlaylistSwitch(IDispatch* /* pItem */)
{
}

void T_WMPOCXEventsProxy::DomainChange(TAutoString /* strDomain */)
{
}

void T_WMPOCXEventsProxy::SwitchedToPlayerApplication()
{
}

void T_WMPOCXEventsProxy::SwitchedToControl()
{
}

void T_WMPOCXEventsProxy::PlayerDockedStateChange()
{
}

void T_WMPOCXEventsProxy::PlayerReconnect()
{
}

void T_WMPOCXEventsProxy::Click(short /* nButton */, short /* nShiftState */, long /* fX */, long /* fY */)
{
}

void T_WMPOCXEventsProxy::DoubleClick(short /* nButton */, short /* nShiftState */, long /* fX */, long /* fY */)
{
}

void T_WMPOCXEventsProxy::KeyDown(short /* nKeyCode */, short /* nShiftState */)
{
}

void T_WMPOCXEventsProxy::KeyPress(short /* nKeyAscii */)
{
}

void T_WMPOCXEventsProxy::KeyUp(short /* nKeyCode */, short /* nShiftState */)
{
}

void T_WMPOCXEventsProxy::MouseDown(short /* nButton */, short /* nShiftState */, long /* fX */, long /* fY */)
{
}

void T_WMPOCXEventsProxy::MouseMove(short /* nButton */, short /* nShiftState */, long /* fX */, long /* fY */)
{
}

void T_WMPOCXEventsProxy::MouseUp(short /* nButton */, short /* nShiftState */, long /* fX */, long /* fY */)
{
}

bool TIWMPMediaProxy::GetisIdentical(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 763);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::GetsourceURL()
{
	static TAutoDispId _dispId(this, 751);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::Getname()
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPMediaProxy::Setname(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPMediaProxy::GetimageSourceWidth()
{
	static TAutoDispId _dispId(this, 752);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMediaProxy::GetimageSourceHeight()
{
	static TAutoDispId _dispId(this, 753);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMediaProxy::GetmarkerCount()
{
	static TAutoDispId _dispId(this, 754);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

double TIWMPMediaProxy::getMarkerTime(long MarkerNum)
{
	static TAutoDispId _dispId(this, 755);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::getMarkerName(long MarkerNum)
{
	static TAutoDispId _dispId(this, 756);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

double TIWMPMediaProxy::Getduration()
{
	static TAutoDispId _dispId(this, 757);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::GetdurationString()
{
	static TAutoDispId _dispId(this, 758);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMediaProxy::GetattributeCount()
{
	static TAutoDispId _dispId(this, 759);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::getAttributeName(long lIndex)
{
	static TAutoDispId _dispId(this, 760);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::getItemInfo(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 761);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMediaProxy::setItemInfo(TAutoString bstrItemName, TAutoString bstrVal)
{
	static TAutoDispId _dispId(this, 762);
	TAutoArgs<2> _args;
	_args[1] = bstrItemName;
	_args[2] = bstrVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPMediaProxy::getItemInfoByAtom(long lAtom)
{
	static TAutoDispId _dispId(this, 765);
	TAutoArgs<1> _args;
	_args[1] = lAtom;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPMediaProxy::isMemberOf(IWMPPlaylist* pPlaylist)
{
	static TAutoDispId _dispId(this, 766);
	TAutoArgs<1> _args;
	_args[1] = pPlaylist;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPMediaProxy::isReadOnlyItem(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 767);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

long TIWMPPlaylistProxy::Getcount()
{
	static TAutoDispId _dispId(this, 201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistProxy::Getname()
{
	static TAutoDispId _dispId(this, 202);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::Setname(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 202);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPPlaylistProxy::GetattributeCount()
{
	static TAutoDispId _dispId(this, 210);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistProxy::GetattributeName(long lIndex)
{
	static TAutoDispId _dispId(this, 211);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::GetItem(TIWMPMediaProxy& object, long lIndex)
{
	static TAutoDispId _dispId(this, 212);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlaylistProxy::getItemInfo(TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 203);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::setItemInfo(TAutoString bstrName, TAutoString bstrValue)
{
	static TAutoDispId _dispId(this, 204);
	TAutoArgs<2> _args;
	_args[1] = bstrName;
	_args[2] = bstrValue;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistProxy::GetisIdentical(IWMPPlaylist* pIWMPPlaylist)
{
	static TAutoDispId _dispId(this, 213);
	TAutoArgs<1> _args;
	_args[1] = pIWMPPlaylist;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::clear()
{
	static TAutoDispId _dispId(this, 205);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::insertItem(long lIndex, IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 206);
	TAutoArgs<2> _args;
	_args[1] = lIndex;
	_args[2] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::appendItem(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 207);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::removeItem(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 208);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistProxy::moveItem(long lIndexOld, long lIndexNew)
{
	static TAutoDispId _dispId(this, 209);
	TAutoArgs<2> _args;
	_args[1] = lIndexOld;
	_args[2] = lIndexNew;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPControlsProxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 62);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::play()
{
	static TAutoDispId _dispId(this, 51);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::stop()
{
	static TAutoDispId _dispId(this, 52);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::pause()
{
	static TAutoDispId _dispId(this, 53);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::fastForward()
{
	static TAutoDispId _dispId(this, 54);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::fastReverse()
{
	static TAutoDispId _dispId(this, 55);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

double TIWMPControlsProxy::GetcurrentPosition()
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::SetcurrentPosition(double arg1)
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPControlsProxy::GetcurrentPositionString()
{
	static TAutoDispId _dispId(this, 57);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::next()
{
	static TAutoDispId _dispId(this, 58);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::previous()
{
	static TAutoDispId _dispId(this, 59);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::GetcurrentItem(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPControlsProxy::SetcurrentItem(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPControlsProxy::GetcurrentMarker()
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::SetcurrentMarker(long arg1)
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPControlsProxy::playItem(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 63);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 113);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::GetautoStart()
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetautoStart(bool arg1)
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSettingsProxy::GetbaseURL()
{
	static TAutoDispId _dispId(this, 108);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetbaseURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 108);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSettingsProxy::GetdefaultFrame()
{
	static TAutoDispId _dispId(this, 109);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetdefaultFrame(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 109);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::GetinvokeURLs()
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetinvokeURLs(bool arg1)
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::Getmute()
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::Setmute(bool arg1)
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettingsProxy::GetplayCount()
{
	static TAutoDispId _dispId(this, 105);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetplayCount(long arg1)
{
	static TAutoDispId _dispId(this, 105);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

double TIWMPSettingsProxy::Getrate()
{
	static TAutoDispId _dispId(this, 106);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::Setrate(double arg1)
{
	static TAutoDispId _dispId(this, 106);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettingsProxy::Getbalance()
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::Setbalance(long arg1)
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettingsProxy::Getvolume()
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::Setvolume(long arg1)
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::getMode(TAutoString bstrMode)
{
	static TAutoDispId _dispId(this, 110);
	TAutoArgs<1> _args;
	_args[1] = bstrMode;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPSettingsProxy::setMode(TAutoString bstrMode, bool varfMode)
{
	static TAutoDispId _dispId(this, 111);
	TAutoArgs<2> _args;
	_args[1] = bstrMode;
	_args[2] = varfMode;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPSettingsProxy::GetenableErrorDialogs()
{
	static TAutoDispId _dispId(this, 112);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettingsProxy::SetenableErrorDialogs(bool arg1)
{
	static TAutoDispId _dispId(this, 112);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPStringCollectionProxy::Getcount()
{
	static TAutoDispId _dispId(this, 401);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPStringCollectionProxy::Item(long lIndex)
{
	static TAutoDispId _dispId(this, 402);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMediaCollectionProxy::add(TIWMPMediaProxy& object, TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 452);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getAll(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 453);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getByName(TIWMPPlaylistProxy& object, TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 454);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getByGenre(TIWMPPlaylistProxy& object, TAutoString bstrGenre)
{
	static TAutoDispId _dispId(this, 455);
	TAutoArgs<1> _args;
	_args[1] = bstrGenre;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getByAuthor(TIWMPPlaylistProxy& object, TAutoString bstrAuthor)
{
	static TAutoDispId _dispId(this, 456);
	TAutoArgs<1> _args;
	_args[1] = bstrAuthor;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getByAlbum(TIWMPPlaylistProxy& object, TAutoString bstrAlbum)
{
	static TAutoDispId _dispId(this, 457);
	TAutoArgs<1> _args;
	_args[1] = bstrAlbum;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::getByAttribute(TIWMPPlaylistProxy& object, TAutoString bstrAttribute, TAutoString bstrValue)
{
	static TAutoDispId _dispId(this, 458);
	TAutoArgs<2> _args;
	_args[1] = bstrAttribute;
	_args[2] = bstrValue;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMediaCollectionProxy::remove(IWMPMedia* pItem, bool varfDeleteFile)
{
	static TAutoDispId _dispId(this, 459);
	TAutoArgs<2> _args;
	_args[1] = pItem;
	_args[2] = varfDeleteFile;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMediaCollectionProxy::getAttributeStringCollection(TIWMPStringCollectionProxy& object, TAutoString bstrAttribute, TAutoString bstrMediaType)
{
	static TAutoDispId _dispId(this, 461);
	TAutoArgs<2> _args;
	_args[1] = bstrAttribute;
	_args[2] = bstrMediaType;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

long TIWMPMediaCollectionProxy::getMediaAtom(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 470);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMediaCollectionProxy::setDeleted(IWMPMedia* pItem, bool varfIsDeleted)
{
	static TAutoDispId _dispId(this, 471);
	TAutoArgs<2> _args;
	_args[1] = pItem;
	_args[2] = varfIsDeleted;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPMediaCollectionProxy::isDeleted(IWMPMedia* pItem)
{
	static TAutoDispId _dispId(this, 472);
	TAutoArgs<1> _args;
	_args[1] = pItem;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

long TIWMPPlaylistArrayProxy::Getcount()
{
	static TAutoDispId _dispId(this, 501);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistArrayProxy::Item(TIWMPPlaylistProxy& object, long lIndex)
{
	static TAutoDispId _dispId(this, 502);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlaylistCollectionProxy::newPlaylist(TIWMPPlaylistProxy& object, TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 552);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlaylistCollectionProxy::getAll(TIWMPPlaylistArrayProxy& object)
{
	static TAutoDispId _dispId(this, 553);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlaylistCollectionProxy::getByName(TIWMPPlaylistArrayProxy& object, TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 554);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlaylistCollectionProxy::remove(IWMPPlaylist* pItem)
{
	static TAutoDispId _dispId(this, 556);
	TAutoArgs<1> _args;
	_args[1] = pItem;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCollectionProxy::setDeleted(IWMPPlaylist* pItem, bool varfIsDeleted)
{
	static TAutoDispId _dispId(this, 560);
	TAutoArgs<2> _args;
	_args[1] = pItem;
	_args[2] = varfIsDeleted;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCollectionProxy::isDeleted(IWMPPlaylist* pItem)
{
	static TAutoDispId _dispId(this, 561);
	TAutoArgs<1> _args;
	_args[1] = pItem;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlaylistCollectionProxy::importPlaylist(TIWMPPlaylistProxy& object, IWMPPlaylist* pItem)
{
	static TAutoDispId _dispId(this, 562);
	TAutoArgs<1> _args;
	_args[1] = pItem;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

long TIWMPNetworkProxy::GetbandWidth()
{
	static TAutoDispId _dispId(this, 801);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetrecoveredPackets()
{
	static TAutoDispId _dispId(this, 802);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPNetworkProxy::GetsourceProtocol()
{
	static TAutoDispId _dispId(this, 803);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetreceivedPackets()
{
	static TAutoDispId _dispId(this, 804);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetlostPackets()
{
	static TAutoDispId _dispId(this, 805);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetreceptionQuality()
{
	static TAutoDispId _dispId(this, 806);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetbufferingCount()
{
	static TAutoDispId _dispId(this, 807);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetbufferingProgress()
{
	static TAutoDispId _dispId(this, 808);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetbufferingTime()
{
	static TAutoDispId _dispId(this, 809);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::SetbufferingTime(long arg1)
{
	static TAutoDispId _dispId(this, 809);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetframeRate()
{
	static TAutoDispId _dispId(this, 810);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetmaxBitRate()
{
	static TAutoDispId _dispId(this, 811);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetbitRate()
{
	static TAutoDispId _dispId(this, 812);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::getProxySettings(TAutoString bstrProtocol)
{
	static TAutoDispId _dispId(this, 813);
	TAutoArgs<1> _args;
	_args[1] = bstrProtocol;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::setProxySettings(TAutoString bstrProtocol, long lProxySetting)
{
	static TAutoDispId _dispId(this, 814);
	TAutoArgs<2> _args;
	_args[1] = bstrProtocol;
	_args[2] = lProxySetting;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPNetworkProxy::getProxyName(TAutoString bstrProtocol)
{
	static TAutoDispId _dispId(this, 815);
	TAutoArgs<1> _args;
	_args[1] = bstrProtocol;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::setProxyName(TAutoString bstrProtocol, TAutoString bstrProxyName)
{
	static TAutoDispId _dispId(this, 816);
	TAutoArgs<2> _args;
	_args[1] = bstrProtocol;
	_args[2] = bstrProxyName;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::getProxyPort(TAutoString bstrProtocol)
{
	static TAutoDispId _dispId(this, 817);
	TAutoArgs<1> _args;
	_args[1] = bstrProtocol;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::setProxyPort(TAutoString bstrProtocol, long lProxyPort)
{
	static TAutoDispId _dispId(this, 818);
	TAutoArgs<2> _args;
	_args[1] = bstrProtocol;
	_args[2] = lProxyPort;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPNetworkProxy::getProxyExceptionList(TAutoString bstrProtocol)
{
	static TAutoDispId _dispId(this, 819);
	TAutoArgs<1> _args;
	_args[1] = bstrProtocol;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::setProxyExceptionList(TAutoString bstrProtocol, TAutoString pbstrExceptionList)
{
	static TAutoDispId _dispId(this, 820);
	TAutoArgs<2> _args;
	_args[1] = bstrProtocol;
	_args[2] = pbstrExceptionList;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPNetworkProxy::getProxyBypassForLocal(TAutoString bstrProtocol)
{
	static TAutoDispId _dispId(this, 821);
	TAutoArgs<1> _args;
	_args[1] = bstrProtocol;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPNetworkProxy::setProxyBypassForLocal(TAutoString bstrProtocol, bool fBypassForLocal)
{
	static TAutoDispId _dispId(this, 822);
	TAutoArgs<2> _args;
	_args[1] = bstrProtocol;
	_args[2] = fBypassForLocal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetmaxBandwidth()
{
	static TAutoDispId _dispId(this, 823);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNetworkProxy::SetmaxBandwidth(long arg1)
{
	static TAutoDispId _dispId(this, 823);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetdownloadProgress()
{
	static TAutoDispId _dispId(this, 824);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetencodedFrameRate()
{
	static TAutoDispId _dispId(this, 825);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNetworkProxy::GetframesSkipped()
{
	static TAutoDispId _dispId(this, 826);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCdromProxy::GetdriveSpecifier()
{
	static TAutoDispId _dispId(this, 251);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCdromProxy::GetPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 252);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCdromProxy::eject()
{
	static TAutoDispId _dispId(this, 253);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPCdromCollectionProxy::Getcount()
{
	static TAutoDispId _dispId(this, 301);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCdromCollectionProxy::Item(TIWMPCdromProxy& object, long lIndex)
{
	static TAutoDispId _dispId(this, 302);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPCdromCollectionProxy::getByDriveSpecifier(TIWMPCdromProxy& object, TAutoString bstrDriveSpecifier)
{
	static TAutoDispId _dispId(this, 303);
	TAutoArgs<1> _args;
	_args[1] = bstrDriveSpecifier;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

TAutoString TIWMPClosedCaptionProxy::GetSAMIStyle()
{
	static TAutoDispId _dispId(this, 951);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaptionProxy::SetSAMIStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 951);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaptionProxy::GetSAMILang()
{
	static TAutoDispId _dispId(this, 952);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaptionProxy::SetSAMILang(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 952);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaptionProxy::GetSAMIFileName()
{
	static TAutoDispId _dispId(this, 953);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaptionProxy::SetSAMIFileName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 953);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaptionProxy::GetcaptioningId()
{
	static TAutoDispId _dispId(this, 954);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaptionProxy::SetcaptioningId(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 954);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPErrorItemProxy::GeterrorCode()
{
	static TAutoDispId _dispId(this, 901);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPErrorItemProxy::GeterrorDescription()
{
	static TAutoDispId _dispId(this, 902);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoVal TIWMPErrorItemProxy::GeterrorContext()
{
	static TAutoDispId _dispId(this, 903);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPErrorItemProxy::Getremedy()
{
	static TAutoDispId _dispId(this, 904);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPErrorItemProxy::GetcustomUrl()
{
	static TAutoDispId _dispId(this, 905);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPErrorProxy::clearErrorQueue()
{
	static TAutoDispId _dispId(this, 851);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPErrorProxy::GeterrorCount()
{
	static TAutoDispId _dispId(this, 852);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPErrorProxy::GetItem(TIWMPErrorItemProxy& object, long dwIndex)
{
	static TAutoDispId _dispId(this, 853);
	TAutoArgs<1> _args;
	_args[1] = dwIndex;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPErrorProxy::webHelp()
{
	static TAutoDispId _dispId(this, 854);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPDVDProxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 1001);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPDVDProxy::Getdomain()
{
	static TAutoDispId _dispId(this, 1002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPDVDProxy::topMenu()
{
	static TAutoDispId _dispId(this, 1003);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDVDProxy::titleMenu()
{
	static TAutoDispId _dispId(this, 1004);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDVDProxy::back()
{
	static TAutoDispId _dispId(this, 1005);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDVDProxy::resume()
{
	static TAutoDispId _dispId(this, 1006);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayerApplicationProxy::switchToPlayerApplication()
{
	static TAutoDispId _dispId(this, 1101);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayerApplicationProxy::switchToControl()
{
	static TAutoDispId _dispId(this, 1102);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPPlayerApplicationProxy::GetplayerDocked()
{
	static TAutoDispId _dispId(this, 1103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayerApplicationProxy::GethasDisplay()
{
	static TAutoDispId _dispId(this, 1104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer4Proxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPPlayer4Proxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPPlayer4Proxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer4Proxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPPlayer4Proxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer4Proxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::Getdvd(TIWMPDVDProxy& object)
{
	static TAutoDispId _dispId(this, 40);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::newPlaylist(TIWMPPlaylistProxy& object, TAutoString bstrName, TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 41);
	TAutoArgs<2> _args;
	_args[1] = bstrName;
	_args[2] = bstrURL;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::newMedia(TIWMPMediaProxy& object, TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 42);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPPlayer4Proxy::Getenabled()
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer4Proxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer4Proxy::GetenableContextMenu()
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetenableContextMenu(bool arg1)
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetuiMode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer4Proxy::GetuiMode()
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayer4Proxy::GetstretchToFit()
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetstretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer4Proxy::GetwindowlessVideo()
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::SetwindowlessVideo(bool arg1)
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer4Proxy::GetisRemote()
{
	static TAutoDispId _dispId(this, 26);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer4Proxy::GetplayerApplication(TIWMPPlayerApplicationProxy& object)
{
	static TAutoDispId _dispId(this, 27);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer4Proxy::openPlayer(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 28);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPCore3Proxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPCore3Proxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPCore3Proxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCore3Proxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPCore3Proxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCore3Proxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore3Proxy::Getdvd(TIWMPDVDProxy& object)
{
	static TAutoDispId _dispId(this, 40);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::newPlaylist(TIWMPPlaylistProxy& object, TAutoString bstrName, TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 41);
	TAutoArgs<2> _args;
	_args[1] = bstrName;
	_args[2] = bstrURL;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPCore3Proxy::newMedia(TIWMPMediaProxy& object, TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 42);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPCore2Proxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPCore2Proxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPCore2Proxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCore2Proxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCore2Proxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPCore2Proxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCore2Proxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCore2Proxy::Getdvd(TIWMPDVDProxy& object)
{
	static TAutoDispId _dispId(this, 40);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPCoreProxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPCoreProxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPCoreProxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCoreProxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPCoreProxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPCoreProxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCoreProxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCoreProxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer3Proxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPPlayer3Proxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPPlayer3Proxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer3Proxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer3Proxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPPlayer3Proxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer3Proxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::Getdvd(TIWMPDVDProxy& object)
{
	static TAutoDispId _dispId(this, 40);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPPlayer3Proxy::Getenabled()
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer3Proxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer3Proxy::GetenableContextMenu()
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetenableContextMenu(bool arg1)
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetuiMode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer3Proxy::GetuiMode()
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayer3Proxy::GetstretchToFit()
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetstretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer3Proxy::GetwindowlessVideo()
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer3Proxy::SetwindowlessVideo(bool arg1)
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer2Proxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPPlayer2Proxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPPlayer2Proxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer2Proxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayer2Proxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPPlayer2Proxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayer2Proxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayer2Proxy::Getenabled()
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer2Proxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer2Proxy::GetenableContextMenu()
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetenableContextMenu(bool arg1)
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetuiMode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayer2Proxy::GetuiMode()
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayer2Proxy::GetstretchToFit()
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetstretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 24);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayer2Proxy::GetwindowlessVideo()
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayer2Proxy::SetwindowlessVideo(bool arg1)
{
	static TAutoDispId _dispId(this, 25);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::close()
{
	static TAutoDispId _dispId(this, 3);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayerProxy::GetURL()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

WMPOpenState TIWMPPlayerProxy::GetopenState()
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<0> _args;
	return (WMPOpenState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPPlayState TIWMPPlayerProxy::GetplayState()
{
	static TAutoDispId _dispId(this, 10);
	TAutoArgs<0> _args;
	return (WMPPlayState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::Getcontrols(TIWMPControlsProxy& object)
{
	static TAutoDispId _dispId(this, 4);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::Getsettings(TIWMPSettingsProxy& object)
{
	static TAutoDispId _dispId(this, 5);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::GetcurrentMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::SetcurrentMedia(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 6);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::GetmediaCollection(TIWMPMediaCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 8);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::GetplaylistCollection(TIWMPPlaylistCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 9);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayerProxy::GetversionInfo()
{
	static TAutoDispId _dispId(this, 11);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::launchURL(TAutoString bstrURL)
{
	static TAutoDispId _dispId(this, 12);
	TAutoArgs<1> _args;
	_args[1] = bstrURL;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::Getnetwork(TIWMPNetworkProxy& object)
{
	static TAutoDispId _dispId(this, 7);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::GetcurrentPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::SetcurrentPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 13);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::GetcdromCollection(TIWMPCdromCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 14);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlayerProxy::GetclosedCaption(TIWMPClosedCaptionProxy& object)
{
	static TAutoDispId _dispId(this, 15);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPPlayerProxy::GetisOnline()
{
	static TAutoDispId _dispId(this, 16);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::GetError(TIWMPErrorProxy& object)
{
	static TAutoDispId _dispId(this, 17);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPPlayerProxy::Getstatus()
{
	static TAutoDispId _dispId(this, 18);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPPlayerProxy::Getenabled()
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 19);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayerProxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 21);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlayerProxy::GetenableContextMenu()
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::SetenableContextMenu(bool arg1)
{
	static TAutoDispId _dispId(this, 22);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPPlayerProxy::SetuiMode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlayerProxy::GetuiMode()
{
	static TAutoDispId _dispId(this, 23);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPErrorItem2Proxy::GeterrorCode()
{
	static TAutoDispId _dispId(this, 901);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPErrorItem2Proxy::GeterrorDescription()
{
	static TAutoDispId _dispId(this, 902);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoVal TIWMPErrorItem2Proxy::GeterrorContext()
{
	static TAutoDispId _dispId(this, 903);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPErrorItem2Proxy::Getremedy()
{
	static TAutoDispId _dispId(this, 904);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPErrorItem2Proxy::GetcustomUrl()
{
	static TAutoDispId _dispId(this, 905);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPErrorItem2Proxy::Getcondition()
{
	static TAutoDispId _dispId(this, 906);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPControls2Proxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 62);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::play()
{
	static TAutoDispId _dispId(this, 51);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::stop()
{
	static TAutoDispId _dispId(this, 52);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::pause()
{
	static TAutoDispId _dispId(this, 53);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::fastForward()
{
	static TAutoDispId _dispId(this, 54);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::fastReverse()
{
	static TAutoDispId _dispId(this, 55);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

double TIWMPControls2Proxy::GetcurrentPosition()
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::SetcurrentPosition(double arg1)
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPControls2Proxy::GetcurrentPositionString()
{
	static TAutoDispId _dispId(this, 57);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::next()
{
	static TAutoDispId _dispId(this, 58);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::previous()
{
	static TAutoDispId _dispId(this, 59);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::GetcurrentItem(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPControls2Proxy::SetcurrentItem(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPControls2Proxy::GetcurrentMarker()
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::SetcurrentMarker(long arg1)
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::playItem(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 63);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls2Proxy::step(long lStep)
{
	static TAutoDispId _dispId(this, 64);
	TAutoArgs<1> _args;
	_args[1] = lStep;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPMedia2Proxy::GetisIdentical(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 763);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::GetsourceURL()
{
	static TAutoDispId _dispId(this, 751);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::Getname()
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPMedia2Proxy::Setname(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPMedia2Proxy::GetimageSourceWidth()
{
	static TAutoDispId _dispId(this, 752);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia2Proxy::GetimageSourceHeight()
{
	static TAutoDispId _dispId(this, 753);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia2Proxy::GetmarkerCount()
{
	static TAutoDispId _dispId(this, 754);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

double TIWMPMedia2Proxy::getMarkerTime(long MarkerNum)
{
	static TAutoDispId _dispId(this, 755);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::getMarkerName(long MarkerNum)
{
	static TAutoDispId _dispId(this, 756);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

double TIWMPMedia2Proxy::Getduration()
{
	static TAutoDispId _dispId(this, 757);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::GetdurationString()
{
	static TAutoDispId _dispId(this, 758);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia2Proxy::GetattributeCount()
{
	static TAutoDispId _dispId(this, 759);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::getAttributeName(long lIndex)
{
	static TAutoDispId _dispId(this, 760);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::getItemInfo(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 761);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMedia2Proxy::setItemInfo(TAutoString bstrItemName, TAutoString bstrVal)
{
	static TAutoDispId _dispId(this, 762);
	TAutoArgs<2> _args;
	_args[1] = bstrItemName;
	_args[2] = bstrVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia2Proxy::getItemInfoByAtom(long lAtom)
{
	static TAutoDispId _dispId(this, 765);
	TAutoArgs<1> _args;
	_args[1] = lAtom;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPMedia2Proxy::isMemberOf(IWMPPlaylist* pPlaylist)
{
	static TAutoDispId _dispId(this, 766);
	TAutoArgs<1> _args;
	_args[1] = pPlaylist;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPMedia2Proxy::isReadOnlyItem(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 767);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMedia2Proxy::GetError(TIWMPErrorItemProxy& object)
{
	static TAutoDispId _dispId(this, 768);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

bool TIWMPMedia3Proxy::GetisIdentical(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 763);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::GetsourceURL()
{
	static TAutoDispId _dispId(this, 751);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::Getname()
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPMedia3Proxy::Setname(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 764);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPMedia3Proxy::GetimageSourceWidth()
{
	static TAutoDispId _dispId(this, 752);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia3Proxy::GetimageSourceHeight()
{
	static TAutoDispId _dispId(this, 753);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia3Proxy::GetmarkerCount()
{
	static TAutoDispId _dispId(this, 754);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

double TIWMPMedia3Proxy::getMarkerTime(long MarkerNum)
{
	static TAutoDispId _dispId(this, 755);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::getMarkerName(long MarkerNum)
{
	static TAutoDispId _dispId(this, 756);
	TAutoArgs<1> _args;
	_args[1] = MarkerNum;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

double TIWMPMedia3Proxy::Getduration()
{
	static TAutoDispId _dispId(this, 757);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::GetdurationString()
{
	static TAutoDispId _dispId(this, 758);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPMedia3Proxy::GetattributeCount()
{
	static TAutoDispId _dispId(this, 759);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::getAttributeName(long lIndex)
{
	static TAutoDispId _dispId(this, 760);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::getItemInfo(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 761);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMedia3Proxy::setItemInfo(TAutoString bstrItemName, TAutoString bstrVal)
{
	static TAutoDispId _dispId(this, 762);
	TAutoArgs<2> _args;
	_args[1] = bstrItemName;
	_args[2] = bstrVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPMedia3Proxy::getItemInfoByAtom(long lAtom)
{
	static TAutoDispId _dispId(this, 765);
	TAutoArgs<1> _args;
	_args[1] = lAtom;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPMedia3Proxy::isMemberOf(IWMPPlaylist* pPlaylist)
{
	static TAutoDispId _dispId(this, 766);
	TAutoArgs<1> _args;
	_args[1] = pPlaylist;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPMedia3Proxy::isReadOnlyItem(TAutoString bstrItemName)
{
	static TAutoDispId _dispId(this, 767);
	TAutoArgs<1> _args;
	_args[1] = bstrItemName;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPMedia3Proxy::GetError(TIWMPErrorItemProxy& object)
{
	static TAutoDispId _dispId(this, 768);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

long TIWMPMedia3Proxy::getAttributeCountByType(TAutoString bstrType, TAutoString bstrLanguage)
{
	static TAutoDispId _dispId(this, 769);
	TAutoArgs<2> _args;
	_args[1] = bstrType;
	_args[2] = bstrLanguage;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoVal TIWMPMedia3Proxy::getItemInfoByType(TAutoString bstrType, TAutoString bstrLanguage, long lIndex)
{
	static TAutoDispId _dispId(this, 770);
	TAutoArgs<3> _args;
	_args[1] = bstrType;
	_args[2] = bstrLanguage;
	_args[3] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataPictureProxy::GetmimeType()
{
	static TAutoDispId _dispId(this, 1051);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataPictureProxy::GetpictureType()
{
	static TAutoDispId _dispId(this, 1052);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataPictureProxy::GetDescription()
{
	static TAutoDispId _dispId(this, 1053);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataPictureProxy::GetURL()
{
	static TAutoDispId _dispId(this, 1054);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataTextProxy::GetDescription()
{
	static TAutoDispId _dispId(this, 1056);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPMetadataTextProxy::Gettext()
{
	static TAutoDispId _dispId(this, 1055);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 113);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::GetautoStart()
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetautoStart(bool arg1)
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSettings2Proxy::GetbaseURL()
{
	static TAutoDispId _dispId(this, 108);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetbaseURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 108);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSettings2Proxy::GetdefaultFrame()
{
	static TAutoDispId _dispId(this, 109);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetdefaultFrame(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 109);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::GetinvokeURLs()
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetinvokeURLs(bool arg1)
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::Getmute()
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::Setmute(bool arg1)
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettings2Proxy::GetplayCount()
{
	static TAutoDispId _dispId(this, 105);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetplayCount(long arg1)
{
	static TAutoDispId _dispId(this, 105);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

double TIWMPSettings2Proxy::Getrate()
{
	static TAutoDispId _dispId(this, 106);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::Setrate(double arg1)
{
	static TAutoDispId _dispId(this, 106);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettings2Proxy::Getbalance()
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::Setbalance(long arg1)
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettings2Proxy::Getvolume()
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::Setvolume(long arg1)
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::getMode(TAutoString bstrMode)
{
	static TAutoDispId _dispId(this, 110);
	TAutoArgs<1> _args;
	_args[1] = bstrMode;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPSettings2Proxy::setMode(TAutoString bstrMode, bool varfMode)
{
	static TAutoDispId _dispId(this, 111);
	TAutoArgs<2> _args;
	_args[1] = bstrMode;
	_args[2] = varfMode;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::GetenableErrorDialogs()
{
	static TAutoDispId _dispId(this, 112);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSettings2Proxy::SetenableErrorDialogs(bool arg1)
{
	static TAutoDispId _dispId(this, 112);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSettings2Proxy::GetdefaultAudioLanguage()
{
	static TAutoDispId _dispId(this, 114);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPSettings2Proxy::GetmediaAccessRights()
{
	static TAutoDispId _dispId(this, 115);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPSettings2Proxy::requestMediaAccessRights(TAutoString bstrDesiredAccess)
{
	static TAutoDispId _dispId(this, 116);
	TAutoArgs<1> _args;
	_args[1] = bstrDesiredAccess;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPControls3Proxy::GetisAvailable(TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 62);
	TAutoArgs<1> _args;
	_args[1] = bstrItem;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::play()
{
	static TAutoDispId _dispId(this, 51);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::stop()
{
	static TAutoDispId _dispId(this, 52);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::pause()
{
	static TAutoDispId _dispId(this, 53);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::fastForward()
{
	static TAutoDispId _dispId(this, 54);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::fastReverse()
{
	static TAutoDispId _dispId(this, 55);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

double TIWMPControls3Proxy::GetcurrentPosition()
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::SetcurrentPosition(double arg1)
{
	static TAutoDispId _dispId(this, 56);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPControls3Proxy::GetcurrentPositionString()
{
	static TAutoDispId _dispId(this, 57);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::next()
{
	static TAutoDispId _dispId(this, 58);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::previous()
{
	static TAutoDispId _dispId(this, 59);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::GetcurrentItem(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPControls3Proxy::SetcurrentItem(IWMPMedia* arg1)
{
	static TAutoDispId _dispId(this, 60);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPControls3Proxy::GetcurrentMarker()
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::SetcurrentMarker(long arg1)
{
	static TAutoDispId _dispId(this, 61);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::playItem(IWMPMedia* pIWMPMedia)
{
	static TAutoDispId _dispId(this, 63);
	TAutoArgs<1> _args;
	_args[1] = pIWMPMedia;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::step(long lStep)
{
	static TAutoDispId _dispId(this, 64);
	TAutoArgs<1> _args;
	_args[1] = lStep;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPControls3Proxy::GetaudioLanguageCount()
{
	static TAutoDispId _dispId(this, 65);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPControls3Proxy::getAudioLanguageID(long lIndex)
{
	static TAutoDispId _dispId(this, 66);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPControls3Proxy::getAudioLanguageDescription(long lIndex)
{
	static TAutoDispId _dispId(this, 67);
	TAutoArgs<1> _args;
	_args[1] = lIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPControls3Proxy::GetcurrentAudioLanguage()
{
	static TAutoDispId _dispId(this, 68);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::SetcurrentAudioLanguage(long arg1)
{
	static TAutoDispId _dispId(this, 68);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPControls3Proxy::GetcurrentAudioLanguageIndex()
{
	static TAutoDispId _dispId(this, 69);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::SetcurrentAudioLanguageIndex(long arg1)
{
	static TAutoDispId _dispId(this, 69);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPControls3Proxy::getLanguageName(long lLangID)
{
	static TAutoDispId _dispId(this, 70);
	TAutoArgs<1> _args;
	_args[1] = lLangID;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPControls3Proxy::GetcurrentPositionTimecode()
{
	static TAutoDispId _dispId(this, 71);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPControls3Proxy::SetcurrentPositionTimecode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 71);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::GetSAMIStyle()
{
	static TAutoDispId _dispId(this, 951);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaption2Proxy::SetSAMIStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 951);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::GetSAMILang()
{
	static TAutoDispId _dispId(this, 952);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaption2Proxy::SetSAMILang(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 952);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::GetSAMIFileName()
{
	static TAutoDispId _dispId(this, 953);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaption2Proxy::SetSAMIFileName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 953);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::GetcaptioningId()
{
	static TAutoDispId _dispId(this, 954);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPClosedCaption2Proxy::SetcaptioningId(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 954);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPClosedCaption2Proxy::GetSAMILangCount()
{
	static TAutoDispId _dispId(this, 955);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::getSAMILangName(long nIndex)
{
	static TAutoDispId _dispId(this, 956);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPClosedCaption2Proxy::getSAMILangID(long nIndex)
{
	static TAutoDispId _dispId(this, 957);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPClosedCaption2Proxy::GetSAMIStyleCount()
{
	static TAutoDispId _dispId(this, 958);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPClosedCaption2Proxy::getSAMIStyleName(long nIndex)
{
	static TAutoDispId _dispId(this, 959);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::GetPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 5601);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlaylistCtrlProxy::SetPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 5601);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::Getcolumns()
{
	static TAutoDispId _dispId(this, 5602);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::Setcolumns(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5602);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlProxy::GetcolumnCount()
{
	static TAutoDispId _dispId(this, 5603);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetcolumnOrder()
{
	static TAutoDispId _dispId(this, 5604);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetcolumnOrder(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5604);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetcolumnsVisible()
{
	static TAutoDispId _dispId(this, 5605);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetcolumnsVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 5605);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetdropDownVisible()
{
	static TAutoDispId _dispId(this, 5607);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdropDownVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 5607);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetplaylistItemsVisible()
{
	static TAutoDispId _dispId(this, 5608);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetplaylistItemsVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 5608);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetcheckboxesVisible()
{
	static TAutoDispId _dispId(this, 5609);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetcheckboxesVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 5609);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 5612);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5612);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 5613);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5613);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetdisabledItemColor()
{
	static TAutoDispId _dispId(this, 5614);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdisabledItemColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5614);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetitemPlayingColor()
{
	static TAutoDispId _dispId(this, 5615);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetitemPlayingColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5615);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetitemPlayingBackgroundColor()
{
	static TAutoDispId _dispId(this, 5616);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetitemPlayingBackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5616);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetbackgroundImage()
{
	static TAutoDispId _dispId(this, 5617);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetbackgroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5617);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetallowItemEditing()
{
	static TAutoDispId _dispId(this, 5618);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetallowItemEditing(bool arg1)
{
	static TAutoDispId _dispId(this, 5618);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GetallowColumnSorting()
{
	static TAutoDispId _dispId(this, 5619);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetallowColumnSorting(bool arg1)
{
	static TAutoDispId _dispId(this, 5619);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetdropDownList()
{
	static TAutoDispId _dispId(this, 5620);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdropDownList(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5620);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetdropDownToolTip()
{
	static TAutoDispId _dispId(this, 5621);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdropDownToolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5621);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::Getcopying()
{
	static TAutoDispId _dispId(this, 5622);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::copy()
{
	static TAutoDispId _dispId(this, 5623);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::abortCopy()
{
	static TAutoDispId _dispId(this, 5624);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::deleteSelected()
{
	static TAutoDispId _dispId(this, 5625);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::deleteSelectedFromLibrary()
{
	static TAutoDispId _dispId(this, 5626);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::moveSelectedUp()
{
	static TAutoDispId _dispId(this, 5628);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::moveSelectedDown()
{
	static TAutoDispId _dispId(this, 5629);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::addSelectedToPlaylist(IWMPPlaylist* pdispPlaylist)
{
	static TAutoDispId _dispId(this, 5630);
	TAutoArgs<1> _args;
	_args[1] = pdispPlaylist;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlProxy::getNextSelectedItem(long nStartIndex)
{
	static TAutoDispId _dispId(this, 5631);
	TAutoArgs<1> _args;
	_args[1] = nStartIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlProxy::getNextCheckedItem(long nStartIndex)
{
	static TAutoDispId _dispId(this, 5632);
	TAutoArgs<1> _args;
	_args[1] = nStartIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setSelectedState(long nIndex, bool vbSelected)
{
	static TAutoDispId _dispId(this, 5633);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = vbSelected;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setCheckedState(long nIndex, bool vbChecked)
{
	static TAutoDispId _dispId(this, 5634);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = vbChecked;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::sortColumn(long nIndex)
{
	static TAutoDispId _dispId(this, 5635);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setColumnResizeMode(long nIndex, TAutoString newMode)
{
	static TAutoDispId _dispId(this, 5636);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = newMode;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setColumnWidth(long nIndex, long nWidth)
{
	static TAutoDispId _dispId(this, 5637);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = nWidth;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetitemErrorColor()
{
	static TAutoDispId _dispId(this, 5642);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetitemErrorColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5642);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlProxy::GetitemCount()
{
	static TAutoDispId _dispId(this, 5643);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::GetitemMedia(TIWMPMediaProxy& object, long nIndex)
{
	static TAutoDispId _dispId(this, 5644);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPPlaylistCtrlProxy::GetitemPlaylist(TIWMPPlaylistProxy& object, long nIndex)
{
	static TAutoDispId _dispId(this, 5645);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

long TIWMPPlaylistCtrlProxy::getNextSelectedItem2(long nStartIndex)
{
	static TAutoDispId _dispId(this, 5646);
	TAutoArgs<1> _args;
	_args[1] = nStartIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlProxy::getNextCheckedItem2(long nStartIndex)
{
	static TAutoDispId _dispId(this, 5647);
	TAutoArgs<1> _args;
	_args[1] = nStartIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setSelectedState2(long nIndex, bool vbSelected)
{
	static TAutoDispId _dispId(this, 5648);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = vbSelected;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::setCheckedState2(long nIndex, bool vbChecked)
{
	static TAutoDispId _dispId(this, 5649);
	TAutoArgs<2> _args;
	_args[1] = nIndex;
	_args[2] = vbChecked;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetleftStatus()
{
	static TAutoDispId _dispId(this, 5650);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetleftStatus(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5650);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetrightStatus()
{
	static TAutoDispId _dispId(this, 5651);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetrightStatus(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5651);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPPlaylistCtrlProxy::GeteditButtonVisible()
{
	static TAutoDispId _dispId(this, 5652);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SeteditButtonVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 5652);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetdropDownImage()
{
	static TAutoDispId _dispId(this, 5653);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdropDownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5653);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetdropDownBackgroundImage()
{
	static TAutoDispId _dispId(this, 5654);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetdropDownBackgroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5654);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPPlaylistCtrlProxy::GethueShift()
{
	static TAutoDispId _dispId(this, 5655);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SethueShift(float arg1)
{
	static TAutoDispId _dispId(this, 5655);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPPlaylistCtrlProxy::Getsaturation()
{
	static TAutoDispId _dispId(this, 5656);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::Setsaturation(float arg1)
{
	static TAutoDispId _dispId(this, 5656);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlProxy::GetstatusColor()
{
	static TAutoDispId _dispId(this, 5658);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlProxy::SetstatusColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5658);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GettitlebarVisible()
{
	static TAutoDispId _dispId(this, 100);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SettitlebarVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 100);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GettitlebarAutoHide()
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SettitlebarAutoHide(bool arg1)
{
	static TAutoDispId _dispId(this, 101);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIAppDispatchProxy::GetcurrentTask()
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SetcurrentTask(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 102);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GetsettingsVisible()
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SetsettingsVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 103);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GetplaylistVisible()
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SetplaylistVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 104);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::gotoSkinMode()
{
	static TAutoDispId _dispId(this, 105);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::adjustLeft(long nDistance)
{
	static TAutoDispId _dispId(this, 106);
	TAutoArgs<1> _args;
	_args[1] = nDistance;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GettaskbarVisible()
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::SettaskbarVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 107);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GettitlebarCurrentlyVisible()
{
	static TAutoDispId _dispId(this, 108);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GetbgPluginRunning()
{
	static TAutoDispId _dispId(this, 109);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIAppDispatchProxy::configurePlugins(long nType)
{
	static TAutoDispId _dispId(this, 110);
	TAutoArgs<1> _args;
	_args[1] = nType;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIAppDispatchProxy::getTimeString(double dTime)
{
	static TAutoDispId _dispId(this, 111);
	TAutoArgs<1> _args;
	_args[1] = dTime;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::GetisXPOrBetter()
{
	static TAutoDispId _dispId(this, 112);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIAppDispatchProxy::Getmaximized()
{
	static TAutoDispId _dispId(this, 113);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPSafeBrowserProxy::GetURL()
{
	static TAutoDispId _dispId(this, 8400);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::SetURL(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8400);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPSafeBrowserProxy::Getstatus()
{
	static TAutoDispId _dispId(this, 8401);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPSafeBrowserProxy::GetpendingDownloads()
{
	static TAutoDispId _dispId(this, 8402);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::showSAMIText(TAutoString samiText)
{
	static TAutoDispId _dispId(this, 8403);
	TAutoArgs<1> _args;
	_args[1] = samiText;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::showLyrics(TAutoString lyrics)
{
	static TAutoDispId _dispId(this, 8404);
	TAutoArgs<1> _args;
	_args[1] = lyrics;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::loadSpecialPage(TAutoString pageName)
{
	static TAutoDispId _dispId(this, 8405);
	TAutoArgs<1> _args;
	_args[1] = pageName;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::goBack()
{
	static TAutoDispId _dispId(this, 8406);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::goForward()
{
	static TAutoDispId _dispId(this, 8407);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::stop()
{
	static TAutoDispId _dispId(this, 8408);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPSafeBrowserProxy::refresh()
{
	static TAutoDispId _dispId(this, 8409);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::Getid()
{
	static TAutoDispId _dispId(this, 2000);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetelementType()
{
	static TAutoDispId _dispId(this, 2001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::Getleft()
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Setleft(long arg1)
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::Gettop()
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Settop(long arg1)
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::Getwidth()
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Setwidth(long arg1)
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::Getheight()
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Setheight(long arg1)
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::GetzIndex()
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetzIndex(long arg1)
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetclippingImage()
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetclippingImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetclippingColor()
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetclippingColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPObjectExtendedPropsProxy::Getvisible()
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Setvisible(bool arg1)
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPObjectExtendedPropsProxy::Getenabled()
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPObjectExtendedPropsProxy::GettabStop()
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SettabStop(bool arg1)
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPObjectExtendedPropsProxy::GetpassThrough()
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetpassThrough(bool arg1)
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GethorizontalAlignment()
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SethorizontalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetverticalAlignment()
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetverticalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::moveTo(long newX, long newY, long moveTime)
{
	static TAutoDispId _dispId(this, 2015);
	TAutoArgs<3> _args;
	_args[1] = newX;
	_args[2] = newY;
	_args[3] = moveTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPObjectExtendedPropsProxy::GetalphaBlend()
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetalphaBlend(long arg1)
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::alphaBlendTo(long newVal, long alphaTime)
{
	static TAutoDispId _dispId(this, 2017);
	TAutoArgs<2> _args;
	_args[1] = newVal;
	_args[2] = alphaTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetaccName()
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetaccName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetaccDescription()
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetaccDescription(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPObjectExtendedPropsProxy::GetaccKeyboardShortcut()
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPObjectExtendedPropsProxy::SetaccKeyboardShortcut(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::Getid()
{
	static TAutoDispId _dispId(this, 2000);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetelementType()
{
	static TAutoDispId _dispId(this, 2001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::Getleft()
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Setleft(long arg1)
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::Gettop()
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Settop(long arg1)
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::Getwidth()
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Setwidth(long arg1)
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::Getheight()
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Setheight(long arg1)
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::GetzIndex()
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetzIndex(long arg1)
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetclippingImage()
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetclippingImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetclippingColor()
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetclippingColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::Getvisible()
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Setvisible(bool arg1)
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::Getenabled()
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::GettabStop()
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SettabStop(bool arg1)
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::GetpassThrough()
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetpassThrough(bool arg1)
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GethorizontalAlignment()
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SethorizontalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetverticalAlignment()
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetverticalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::moveTo(long newX, long newY, long moveTime)
{
	static TAutoDispId _dispId(this, 2015);
	TAutoArgs<3> _args;
	_args[1] = newX;
	_args[2] = newY;
	_args[3] = moveTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPLayoutSubViewProxy::GetalphaBlend()
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetalphaBlend(long arg1)
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::alphaBlendTo(long newVal, long alphaTime)
{
	static TAutoDispId _dispId(this, 2017);
	TAutoArgs<2> _args;
	_args[1] = newVal;
	_args[2] = alphaTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetaccName()
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetaccName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetaccDescription()
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetaccDescription(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetaccKeyboardShortcut()
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetaccKeyboardShortcut(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 2300);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2300);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 2301);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2301);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSubViewProxy::GetbackgroundImage()
{
	static TAutoDispId _dispId(this, 2302);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetbackgroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2302);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::GetbackgroundTiled()
{
	static TAutoDispId _dispId(this, 2303);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetbackgroundTiled(bool arg1)
{
	static TAutoDispId _dispId(this, 2303);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSubViewProxy::GetbackgroundImageHueShift()
{
	static TAutoDispId _dispId(this, 2304);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetbackgroundImageHueShift(float arg1)
{
	static TAutoDispId _dispId(this, 2304);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSubViewProxy::GetbackgroundImageSaturation()
{
	static TAutoDispId _dispId(this, 2305);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetbackgroundImageSaturation(float arg1)
{
	static TAutoDispId _dispId(this, 2305);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSubViewProxy::GetresizeBackgroundImage()
{
	static TAutoDispId _dispId(this, 2306);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSubViewProxy::SetresizeBackgroundImage(bool arg1)
{
	static TAutoDispId _dispId(this, 2306);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::Getid()
{
	static TAutoDispId _dispId(this, 2000);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetelementType()
{
	static TAutoDispId _dispId(this, 2001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::Getleft()
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setleft(long arg1)
{
	static TAutoDispId _dispId(this, 2002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::Gettop()
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Settop(long arg1)
{
	static TAutoDispId _dispId(this, 2003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::Getwidth()
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setwidth(long arg1)
{
	static TAutoDispId _dispId(this, 2004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::Getheight()
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setheight(long arg1)
{
	static TAutoDispId _dispId(this, 2005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetzIndex()
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetzIndex(long arg1)
{
	static TAutoDispId _dispId(this, 2006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetclippingImage()
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetclippingImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2007);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetclippingColor()
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetclippingColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::Getvisible()
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setvisible(bool arg1)
{
	static TAutoDispId _dispId(this, 2009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::Getenabled()
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 2010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::GettabStop()
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SettabStop(bool arg1)
{
	static TAutoDispId _dispId(this, 2011);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::GetpassThrough()
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetpassThrough(bool arg1)
{
	static TAutoDispId _dispId(this, 2012);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GethorizontalAlignment()
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SethorizontalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2013);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetverticalAlignment()
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetverticalAlignment(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2014);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::moveTo(long newX, long newY, long moveTime)
{
	static TAutoDispId _dispId(this, 2015);
	TAutoArgs<3> _args;
	_args[1] = newX;
	_args[2] = newY;
	_args[3] = moveTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetalphaBlend()
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetalphaBlend(long arg1)
{
	static TAutoDispId _dispId(this, 2016);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::alphaBlendTo(long newVal, long alphaTime)
{
	static TAutoDispId _dispId(this, 2017);
	TAutoArgs<2> _args;
	_args[1] = newVal;
	_args[2] = alphaTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetaccName()
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetaccName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetaccDescription()
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetaccDescription(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2019);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetaccKeyboardShortcut()
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetaccKeyboardShortcut(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2020);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 2300);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2300);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 2301);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2301);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetbackgroundImage()
{
	static TAutoDispId _dispId(this, 2302);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetbackgroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2302);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::GetbackgroundTiled()
{
	static TAutoDispId _dispId(this, 2303);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetbackgroundTiled(bool arg1)
{
	static TAutoDispId _dispId(this, 2303);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutViewProxy::GetbackgroundImageHueShift()
{
	static TAutoDispId _dispId(this, 2304);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetbackgroundImageHueShift(float arg1)
{
	static TAutoDispId _dispId(this, 2304);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutViewProxy::GetbackgroundImageSaturation()
{
	static TAutoDispId _dispId(this, 2305);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetbackgroundImageSaturation(float arg1)
{
	static TAutoDispId _dispId(this, 2305);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::GetresizeBackgroundImage()
{
	static TAutoDispId _dispId(this, 2306);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetresizeBackgroundImage(bool arg1)
{
	static TAutoDispId _dispId(this, 2306);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::Gettitle()
{
	static TAutoDispId _dispId(this, 2307);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Settitle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2307);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::Getcategory()
{
	static TAutoDispId _dispId(this, 2308);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::Setcategory(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2308);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutViewProxy::GetfocusObjectID()
{
	static TAutoDispId _dispId(this, 2309);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetfocusObjectID(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2309);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::GettitleBar()
{
	static TAutoDispId _dispId(this, 2311);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPLayoutViewProxy::Getresizable()
{
	static TAutoDispId _dispId(this, 2312);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GettimerInterval()
{
	static TAutoDispId _dispId(this, 2313);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SettimerInterval(long arg1)
{
	static TAutoDispId _dispId(this, 2313);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetminWidth()
{
	static TAutoDispId _dispId(this, 2314);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetminWidth(long arg1)
{
	static TAutoDispId _dispId(this, 2314);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetmaxWidth()
{
	static TAutoDispId _dispId(this, 2315);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetmaxWidth(long arg1)
{
	static TAutoDispId _dispId(this, 2315);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetminHeight()
{
	static TAutoDispId _dispId(this, 2316);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetminHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2316);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutViewProxy::GetmaxHeight()
{
	static TAutoDispId _dispId(this, 2317);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::SetmaxHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2317);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::close()
{
	static TAutoDispId _dispId(this, 2318);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::minimize()
{
	static TAutoDispId _dispId(this, 2319);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::maximize()
{
	static TAutoDispId _dispId(this, 2320);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::restore()
{
	static TAutoDispId _dispId(this, 2321);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::size(TAutoString bstrDirection)
{
	static TAutoDispId _dispId(this, 2322);
	TAutoArgs<1> _args;
	_args[1] = bstrDirection;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::returnToMediaCenter()
{
	static TAutoDispId _dispId(this, 2323);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPLayoutViewProxy::updateWindow()
{
	static TAutoDispId _dispId(this, 2324);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

IDispatch* TIWMPEventObjectProxy::GetsrcElement()
{
	static TAutoDispId _dispId(this, 2200);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEventObjectProxy::GetaltKey()
{
	static TAutoDispId _dispId(this, 2201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEventObjectProxy::GetctrlKey()
{
	static TAutoDispId _dispId(this, 2202);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEventObjectProxy::GetshiftKey()
{
	static TAutoDispId _dispId(this, 2203);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

IDispatch* TIWMPEventObjectProxy::GetfromElement()
{
	static TAutoDispId _dispId(this, 2204);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

IDispatch* TIWMPEventObjectProxy::GettoElement()
{
	static TAutoDispId _dispId(this, 2205);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEventObjectProxy::SetkeyCode(long arg1)
{
	static TAutoDispId _dispId(this, 2206);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetkeyCode()
{
	static TAutoDispId _dispId(this, 2206);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::Getbutton()
{
	static TAutoDispId _dispId(this, 2207);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::Getx()
{
	static TAutoDispId _dispId(this, 2208);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::Gety()
{
	static TAutoDispId _dispId(this, 2209);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetclientX()
{
	static TAutoDispId _dispId(this, 2210);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetclientY()
{
	static TAutoDispId _dispId(this, 2211);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetoffsetX()
{
	static TAutoDispId _dispId(this, 2212);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetoffsetY()
{
	static TAutoDispId _dispId(this, 2213);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetscreenX()
{
	static TAutoDispId _dispId(this, 2214);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetscreenY()
{
	static TAutoDispId _dispId(this, 2215);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetscreenWidth()
{
	static TAutoDispId _dispId(this, 2216);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEventObjectProxy::GetscreenHeight()
{
	static TAutoDispId _dispId(this, 2217);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::Gettitle()
{
	static TAutoDispId _dispId(this, 2500);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

float TIWMPThemeProxy::Getversion()
{
	static TAutoDispId _dispId(this, 2501);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::GetauthorVersion()
{
	static TAutoDispId _dispId(this, 2502);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::Getauthor()
{
	static TAutoDispId _dispId(this, 2503);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::Getcopyright()
{
	static TAutoDispId _dispId(this, 2504);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::GetcurrentViewID()
{
	static TAutoDispId _dispId(this, 2505);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::SetcurrentViewID(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2505);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::showErrorDialog()
{
	static TAutoDispId _dispId(this, 2506);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::logString(TAutoString stringVal)
{
	static TAutoDispId _dispId(this, 2507);
	TAutoArgs<1> _args;
	_args[1] = stringVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::openView(TAutoString viewID)
{
	static TAutoDispId _dispId(this, 2508);
	TAutoArgs<1> _args;
	_args[1] = viewID;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::openViewRelative(TAutoString viewID, long x, long y)
{
	static TAutoDispId _dispId(this, 2515);
	TAutoArgs<3> _args;
	_args[1] = viewID;
	_args[2] = x;
	_args[3] = y;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::closeView(TAutoString viewID)
{
	static TAutoDispId _dispId(this, 2509);
	TAutoArgs<1> _args;
	_args[1] = viewID;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::openDialog(TAutoString dialogType, TAutoString parameters)
{
	static TAutoDispId _dispId(this, 2510);
	TAutoArgs<2> _args;
	_args[1] = dialogType;
	_args[2] = parameters;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::loadString(TAutoString bstrString)
{
	static TAutoDispId _dispId(this, 2511);
	TAutoArgs<1> _args;
	_args[1] = bstrString;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPThemeProxy::loadPreference(TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 2512);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::savePreference(TAutoString bstrName, TAutoString bstrValue)
{
	static TAutoDispId _dispId(this, 2513);
	TAutoArgs<2> _args;
	_args[1] = bstrName;
	_args[2] = bstrValue;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPThemeProxy::playSound(TAutoString bstrFilename)
{
	static TAutoDispId _dispId(this, 2514);
	TAutoArgs<1> _args;
	_args[1] = bstrFilename;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GeteffectType()
{
	static TAutoDispId _dispId(this, 2800);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SeteffectType(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2800);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GeteffectPreset()
{
	static TAutoDispId _dispId(this, 2801);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SeteffectPreset(long arg1)
{
	static TAutoDispId _dispId(this, 2801);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetsettingsView()
{
	static TAutoDispId _dispId(this, 2802);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetsettingsView(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2802);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetvideoZoom()
{
	static TAutoDispId _dispId(this, 2803);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetvideoZoom(long arg1)
{
	static TAutoDispId _dispId(this, 2803);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetvideoShrinkToFit()
{
	static TAutoDispId _dispId(this, 2804);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetvideoShrinkToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 2804);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetvideoStretchToFit()
{
	static TAutoDispId _dispId(this, 2805);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetvideoStretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 2805);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetuserVideoStretchToFit()
{
	static TAutoDispId _dispId(this, 2867);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetuserVideoStretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 2867);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowCaptions()
{
	static TAutoDispId _dispId(this, 2807);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowCaptions(bool arg1)
{
	static TAutoDispId _dispId(this, 2807);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowTitles()
{
	static TAutoDispId _dispId(this, 2808);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowTitles(bool arg1)
{
	static TAutoDispId _dispId(this, 2808);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowEffects()
{
	static TAutoDispId _dispId(this, 2809);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowEffects(bool arg1)
{
	static TAutoDispId _dispId(this, 2809);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowFullScreenPlaylist()
{
	static TAutoDispId _dispId(this, 2811);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowFullScreenPlaylist(bool arg1)
{
	static TAutoDispId _dispId(this, 2811);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetcontrastMode()
{
	static TAutoDispId _dispId(this, 2813);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::getNamedString(TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 2810);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::getDurationStringFromSeconds(long lDurationVal)
{
	static TAutoDispId _dispId(this, 2815);
	TAutoArgs<1> _args;
	_args[1] = lDurationVal;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetdisplayView()
{
	static TAutoDispId _dispId(this, 2816);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetdisplayView(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2816);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetmetadataView()
{
	static TAutoDispId _dispId(this, 2817);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetmetadataView(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2817);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowSettings()
{
	static TAutoDispId _dispId(this, 2818);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowSettings(bool arg1)
{
	static TAutoDispId _dispId(this, 2818);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowResizeBars()
{
	static TAutoDispId _dispId(this, 2819);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowResizeBars(bool arg1)
{
	static TAutoDispId _dispId(this, 2819);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowPlaylist()
{
	static TAutoDispId _dispId(this, 2820);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowPlaylist(bool arg1)
{
	static TAutoDispId _dispId(this, 2820);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetshowMetadata()
{
	static TAutoDispId _dispId(this, 2821);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetshowMetadata(bool arg1)
{
	static TAutoDispId _dispId(this, 2821);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetsettingsWidth()
{
	static TAutoDispId _dispId(this, 2822);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetsettingsWidth(long arg1)
{
	static TAutoDispId _dispId(this, 2822);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetsettingsHeight()
{
	static TAutoDispId _dispId(this, 2823);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetsettingsHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2823);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetplaylistWidth()
{
	static TAutoDispId _dispId(this, 2824);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetplaylistWidth(long arg1)
{
	static TAutoDispId _dispId(this, 2824);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetplaylistHeight()
{
	static TAutoDispId _dispId(this, 2825);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetplaylistHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2825);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetmetadataWidth()
{
	static TAutoDispId _dispId(this, 2826);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetmetadataWidth(long arg1)
{
	static TAutoDispId _dispId(this, 2826);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetmetadataHeight()
{
	static TAutoDispId _dispId(this, 2827);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetmetadataHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2827);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetfullScreenAvailable()
{
	static TAutoDispId _dispId(this, 2828);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetfullScreenAvailable(bool arg1)
{
	static TAutoDispId _dispId(this, 2828);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetfullScreenRequest()
{
	static TAutoDispId _dispId(this, 2829);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetfullScreenRequest(bool arg1)
{
	static TAutoDispId _dispId(this, 2829);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetquickHide()
{
	static TAutoDispId _dispId(this, 2830);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetquickHide(bool arg1)
{
	static TAutoDispId _dispId(this, 2830);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetdisplayPreset()
{
	static TAutoDispId _dispId(this, 2831);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetdisplayPreset(long arg1)
{
	static TAutoDispId _dispId(this, 2831);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetsettingsPreset()
{
	static TAutoDispId _dispId(this, 2832);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetsettingsPreset(long arg1)
{
	static TAutoDispId _dispId(this, 2832);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetmetadataPreset()
{
	static TAutoDispId _dispId(this, 2833);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetmetadataPreset(long arg1)
{
	static TAutoDispId _dispId(this, 2833);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetuserDisplayView()
{
	static TAutoDispId _dispId(this, 2834);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetuserWMPDisplayView()
{
	static TAutoDispId _dispId(this, 2835);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetuserDisplayPreset()
{
	static TAutoDispId _dispId(this, 2836);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetuserWMPDisplayPreset()
{
	static TAutoDispId _dispId(this, 2837);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetdynamicRangeControl()
{
	static TAutoDispId _dispId(this, 2838);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetdynamicRangeControl(long arg1)
{
	static TAutoDispId _dispId(this, 2838);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetslowRate()
{
	static TAutoDispId _dispId(this, 2839);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetslowRate(float arg1)
{
	static TAutoDispId _dispId(this, 2839);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetfastRate()
{
	static TAutoDispId _dispId(this, 2840);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetfastRate(float arg1)
{
	static TAutoDispId _dispId(this, 2840);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetbuttonHueShift()
{
	static TAutoDispId _dispId(this, 2841);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetbuttonHueShift(float arg1)
{
	static TAutoDispId _dispId(this, 2841);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetbuttonSaturation()
{
	static TAutoDispId _dispId(this, 2842);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetbuttonSaturation(float arg1)
{
	static TAutoDispId _dispId(this, 2842);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetbackHueShift()
{
	static TAutoDispId _dispId(this, 2843);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetbackHueShift(float arg1)
{
	static TAutoDispId _dispId(this, 2843);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPLayoutSettingsDispatchProxy::GetbackSaturation()
{
	static TAutoDispId _dispId(this, 2844);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetbackSaturation(float arg1)
{
	static TAutoDispId _dispId(this, 2844);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetvizRequest()
{
	static TAutoDispId _dispId(this, 2845);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetvizRequest(long arg1)
{
	static TAutoDispId _dispId(this, 2845);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetvizAutoSelect()
{
	static TAutoDispId _dispId(this, 2846);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetvizAutoSelect(bool arg1)
{
	static TAutoDispId _dispId(this, 2846);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 2847);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetappColorMedium()
{
	static TAutoDispId _dispId(this, 2848);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetappColorDark()
{
	static TAutoDispId _dispId(this, 2849);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GettoolbarButtonHighlight()
{
	static TAutoDispId _dispId(this, 2855);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GettoolbarButtonShadow()
{
	static TAutoDispId _dispId(this, 2856);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GettoolbarButtonFace()
{
	static TAutoDispId _dispId(this, 2857);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetitemPlayingColor()
{
	static TAutoDispId _dispId(this, 2850);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetitemPlayingBackgroundColor()
{
	static TAutoDispId _dispId(this, 2851);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetitemErrorColor()
{
	static TAutoDispId _dispId(this, 2852);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetappColorLimited()
{
	static TAutoDispId _dispId(this, 2853);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetappColorBlackBackground()
{
	static TAutoDispId _dispId(this, 2854);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetappColorBlackBackground(bool arg1)
{
	static TAutoDispId _dispId(this, 2854);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetuserWMPSettingsView()
{
	static TAutoDispId _dispId(this, 2858);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetuserWMPSettingsPreset()
{
	static TAutoDispId _dispId(this, 2859);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetuserWMPShowSettings()
{
	static TAutoDispId _dispId(this, 2860);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPLayoutSettingsDispatchProxy::GetuserWMPMetadataView()
{
	static TAutoDispId _dispId(this, 2861);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetuserWMPMetadataPreset()
{
	static TAutoDispId _dispId(this, 2862);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetuserWMPShowMetadata()
{
	static TAutoDispId _dispId(this, 2863);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPLayoutSettingsDispatchProxy::GetcaptionsHeight()
{
	static TAutoDispId _dispId(this, 2864);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetcaptionsHeight(long arg1)
{
	static TAutoDispId _dispId(this, 2864);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetsnapToVideo()
{
	static TAutoDispId _dispId(this, 2865);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetsnapToVideo(bool arg1)
{
	static TAutoDispId _dispId(this, 2865);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPLayoutSettingsDispatchProxy::GetpinFullScreenControls()
{
	static TAutoDispId _dispId(this, 2866);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLayoutSettingsDispatchProxy::SetpinFullScreenControls(bool arg1)
{
	static TAutoDispId _dispId(this, 2866);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::GetviewFriendlyName(TAutoString bstrView)
{
	static TAutoDispId _dispId(this, 2901);
	TAutoArgs<1> _args;
	_args[1] = bstrView;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNowPlayingHelperDispatchProxy::GetviewPresetCount(TAutoString bstrView)
{
	static TAutoDispId _dispId(this, 2902);
	TAutoArgs<1> _args;
	_args[1] = bstrView;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::GetviewPresetName(TAutoString bstrView, long nPresetIndex)
{
	static TAutoDispId _dispId(this, 2903);
	TAutoArgs<2> _args;
	_args[1] = bstrView;
	_args[2] = nPresetIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::GeteffectFriendlyName(TAutoString bstrEffect)
{
	static TAutoDispId _dispId(this, 2904);
	TAutoArgs<1> _args;
	_args[1] = bstrEffect;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::GeteffectPresetName(TAutoString bstrEffect, long nPresetIndex)
{
	static TAutoDispId _dispId(this, 2905);
	TAutoArgs<2> _args;
	_args[1] = bstrEffect;
	_args[2] = nPresetIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::resolveDisplayView(bool fSafe)
{
	static TAutoDispId _dispId(this, 2909);
	TAutoArgs<1> _args;
	_args[1] = fSafe;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPNowPlayingHelperDispatchProxy::isValidDisplayView(TAutoString bstrView)
{
	static TAutoDispId _dispId(this, 2910);
	TAutoArgs<1> _args;
	_args[1] = bstrView;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::getSkinFile()
{
	static TAutoDispId _dispId(this, 2911);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPNowPlayingHelperDispatchProxy::GetcaptionsAvailable()
{
	static TAutoDispId _dispId(this, 2912);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNowPlayingHelperDispatchProxy::GetlinkAvailable()
{
	static TAutoDispId _dispId(this, 2913);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNowPlayingHelperDispatchProxy::GetlinkRequest()
{
	static TAutoDispId _dispId(this, 2914);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNowPlayingHelperDispatchProxy::SetlinkRequest(long arg1)
{
	static TAutoDispId _dispId(this, 2914);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::GetlinkRequestParams()
{
	static TAutoDispId _dispId(this, 2915);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNowPlayingHelperDispatchProxy::SetlinkRequestParams(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 2915);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPNowPlayingHelperDispatchProxy::GetisXPOrBetter()
{
	static TAutoDispId _dispId(this, 2916);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPNowPlayingHelperDispatchProxy::getCurrentArtID(bool fLargeArt)
{
	static TAutoDispId _dispId(this, 2917);
	TAutoArgs<1> _args;
	_args[1] = fLargeArt;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::getTimeString(double dTime)
{
	static TAutoDispId _dispId(this, 2918);
	TAutoArgs<1> _args;
	_args[1] = dTime;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::getCurrentScriptCommand(TAutoString bstrType)
{
	static TAutoDispId _dispId(this, 2919);
	TAutoArgs<1> _args;
	_args[1] = bstrType;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPNowPlayingHelperDispatchProxy::calcLayout(long lWidth, long lHeight, bool vbCaptions, bool vbBanner)
{
	static TAutoDispId _dispId(this, 2920);
	TAutoArgs<4> _args;
	_args[1] = lWidth;
	_args[2] = lHeight;
	_args[3] = vbCaptions;
	_args[4] = vbBanner;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPNowPlayingHelperDispatchProxy::getLayoutSize(long nProp)
{
	static TAutoDispId _dispId(this, 2921);
	TAutoArgs<1> _args;
	_args[1] = nProp;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

IDispatch* TIWMPNowPlayingHelperDispatchProxy::getRootPlaylist(IDispatch* pPlaylist)
{
	static TAutoDispId _dispId(this, 2922);
	TAutoArgs<1> _args;
	_args[1] = pPlaylist;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPNowPlayingHelperDispatchProxy::getHTMLViewURL()
{
	static TAutoDispId _dispId(this, 2923);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

bool TIWMPNowPlayingHelperDispatchProxy::GetcanSendLink()
{
	static TAutoDispId _dispId(this, 2924);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNowPlayingHelperDispatchProxy::sendLink(double dblStartTime, double dblEndTime)
{
	static TAutoDispId _dispId(this, 2925);
	TAutoArgs<2> _args;
	_args[1] = dblStartTime;
	_args[2] = dblEndTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

IUnknown* TIWMPNowPlayingHelperDispatchProxy::GeteditObj()
{
	static TAutoDispId _dispId(this, 2926);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPNowPlayingHelperDispatchProxy::SeteditObj(IUnknown* arg1)
{
	static TAutoDispId _dispId(this, 2926);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlEventsProxy::IWMPButtonCtrlEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5120:
			onclick();
			break;
	}
}

HRESULT TIWMPButtonCtrlEventsProxy::onclick()
{
	return S_OK;
}

TAutoString TIWMPButtonCtrlProxy::Getimage()
{
	static TAutoDispId _dispId(this, 5102);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::Setimage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5102);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GethoverImage()
{
	static TAutoDispId _dispId(this, 5103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SethoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5103);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GetdownImage()
{
	static TAutoDispId _dispId(this, 5104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SetdownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5104);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GetdisabledImage()
{
	static TAutoDispId _dispId(this, 5105);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SetdisabledImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5105);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GethoverDownImage()
{
	static TAutoDispId _dispId(this, 5106);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SethoverDownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5106);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPButtonCtrlProxy::Gettiled()
{
	static TAutoDispId _dispId(this, 5107);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::Settiled(bool arg1)
{
	static TAutoDispId _dispId(this, 5107);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 5108);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5108);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPButtonCtrlProxy::Getdown()
{
	static TAutoDispId _dispId(this, 5109);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::Setdown(bool arg1)
{
	static TAutoDispId _dispId(this, 5109);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPButtonCtrlProxy::Getsticky()
{
	static TAutoDispId _dispId(this, 5110);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::Setsticky(bool arg1)
{
	static TAutoDispId _dispId(this, 5110);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GetupToolTip()
{
	static TAutoDispId _dispId(this, 5112);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SetupToolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5112);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::GetdownToolTip()
{
	static TAutoDispId _dispId(this, 5113);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::SetdownToolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5113);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPButtonCtrlProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5114);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPButtonCtrlProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5114);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::GetselectedItem()
{
	static TAutoDispId _dispId(this, 6108);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetselectedItem(long arg1)
{
	static TAutoDispId _dispId(this, 6108);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPListBoxCtrlProxy::Getsorted()
{
	static TAutoDispId _dispId(this, 6100);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::Setsorted(bool arg1)
{
	static TAutoDispId _dispId(this, 6100);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPListBoxCtrlProxy::Getmultiselect()
{
	static TAutoDispId _dispId(this, 6101);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::Setmultiselect(bool arg1)
{
	static TAutoDispId _dispId(this, 6101);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPListBoxCtrlProxy::GetreadOnly()
{
	static TAutoDispId _dispId(this, 6102);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetreadOnly(bool arg1)
{
	static TAutoDispId _dispId(this, 6102);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPListBoxCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 6103);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6103);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPListBoxCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 6104);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6104);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::GetfontSize()
{
	static TAutoDispId _dispId(this, 6105);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetfontSize(long arg1)
{
	static TAutoDispId _dispId(this, 6105);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPListBoxCtrlProxy::GetfontStyle()
{
	static TAutoDispId _dispId(this, 6106);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetfontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6106);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPListBoxCtrlProxy::GetfontFace()
{
	static TAutoDispId _dispId(this, 6107);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetfontFace(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6107);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::GetitemCount()
{
	static TAutoDispId _dispId(this, 6109);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::GetfirstVisibleItem()
{
	static TAutoDispId _dispId(this, 6110);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetfirstVisibleItem(long arg1)
{
	static TAutoDispId _dispId(this, 6110);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetpopUp(bool arg1)
{
	static TAutoDispId _dispId(this, 6120);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::GetfocusItem()
{
	static TAutoDispId _dispId(this, 6121);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::SetfocusItem(long arg1)
{
	static TAutoDispId _dispId(this, 6121);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPListBoxCtrlProxy::Getborder()
{
	static TAutoDispId _dispId(this, 6125);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::Setborder(bool arg1)
{
	static TAutoDispId _dispId(this, 6125);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPListBoxCtrlProxy::getItem(long nPos)
{
	static TAutoDispId _dispId(this, 6111);
	TAutoArgs<1> _args;
	_args[1] = nPos;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::insertItem(long nPos, TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6112);
	TAutoArgs<2> _args;
	_args[1] = nPos;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::appendItem(TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6113);
	TAutoArgs<1> _args;
	_args[1] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::replaceItem(long nPos, TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6114);
	TAutoArgs<2> _args;
	_args[1] = nPos;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::deleteItem(long nPos)
{
	static TAutoDispId _dispId(this, 6115);
	TAutoArgs<1> _args;
	_args[1] = nPos;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::deleteAll()
{
	static TAutoDispId _dispId(this, 6116);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::findItem(long nStartIndex, TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6117);
	TAutoArgs<2> _args;
	_args[1] = nStartIndex;
	_args[2] = newVal;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPListBoxCtrlProxy::getNextSelectedItem(long nStartIndex)
{
	static TAutoDispId _dispId(this, 6118);
	TAutoArgs<1> _args;
	_args[1] = nStartIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::setSelectedState(long nPos, bool vbSelected)
{
	static TAutoDispId _dispId(this, 6122);
	TAutoArgs<2> _args;
	_args[1] = nPos;
	_args[2] = vbSelected;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::show()
{
	static TAutoDispId _dispId(this, 6123);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxCtrlProxy::dismiss()
{
	static TAutoDispId _dispId(this, 6124);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPListBoxItemProxy::Setvalue(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6119);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlColumnProxy::GetcolumnName()
{
	static TAutoDispId _dispId(this, 5670);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlColumnProxy::SetcolumnName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5670);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlColumnProxy::GetcolumnID()
{
	static TAutoDispId _dispId(this, 5671);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlColumnProxy::SetcolumnID(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5671);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPlaylistCtrlColumnProxy::GetcolumnResizeMode()
{
	static TAutoDispId _dispId(this, 5672);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlColumnProxy::SetcolumnResizeMode(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5672);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPPlaylistCtrlColumnProxy::GetcolumnWidth()
{
	static TAutoDispId _dispId(this, 5673);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPlaylistCtrlColumnProxy::SetcolumnWidth(long arg1)
{
	static TAutoDispId _dispId(this, 5673);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlEventsProxy::IWMPSliderCtrlEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5430:
			ondragbegin();
			break;

		case 5431:
			ondragend();
			break;

		case 5432:
			onpositionchange();
			break;
	}
}

HRESULT TIWMPSliderCtrlEventsProxy::ondragbegin()
{
	return S_OK;
}

HRESULT TIWMPSliderCtrlEventsProxy::ondragend()
{
	return S_OK;
}

HRESULT TIWMPSliderCtrlEventsProxy::onpositionchange()
{
	return S_OK;
}

TAutoString TIWMPSliderCtrlProxy::Getdirection()
{
	static TAutoDispId _dispId(this, 5400);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setdirection(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5400);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSliderCtrlProxy::Getslide()
{
	static TAutoDispId _dispId(this, 5402);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setslide(bool arg1)
{
	static TAutoDispId _dispId(this, 5402);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSliderCtrlProxy::Gettiled()
{
	static TAutoDispId _dispId(this, 5403);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Settiled(bool arg1)
{
	static TAutoDispId _dispId(this, 5403);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 5404);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5404);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetforegroundEndColor()
{
	static TAutoDispId _dispId(this, 5405);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetforegroundEndColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5405);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 5406);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5406);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetbackgroundEndColor()
{
	static TAutoDispId _dispId(this, 5407);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetbackgroundEndColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5407);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetdisabledColor()
{
	static TAutoDispId _dispId(this, 5408);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetdisabledColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5408);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 5409);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5409);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetforegroundImage()
{
	static TAutoDispId _dispId(this, 5410);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetforegroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5410);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetbackgroundImage()
{
	static TAutoDispId _dispId(this, 5411);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetbackgroundImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5411);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetbackgroundHoverImage()
{
	static TAutoDispId _dispId(this, 5412);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetbackgroundHoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5412);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetdisabledImage()
{
	static TAutoDispId _dispId(this, 5413);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetdisabledImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5413);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetthumbImage()
{
	static TAutoDispId _dispId(this, 5414);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetthumbImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5414);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetthumbHoverImage()
{
	static TAutoDispId _dispId(this, 5415);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetthumbHoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5415);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetthumbDownImage()
{
	static TAutoDispId _dispId(this, 5416);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetthumbDownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5416);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetthumbDisabledImage()
{
	static TAutoDispId _dispId(this, 5417);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetthumbDisabledImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5417);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPSliderCtrlProxy::Getmin()
{
	static TAutoDispId _dispId(this, 5418);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setmin(float arg1)
{
	static TAutoDispId _dispId(this, 5418);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPSliderCtrlProxy::Getmax()
{
	static TAutoDispId _dispId(this, 5419);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setmax(float arg1)
{
	static TAutoDispId _dispId(this, 5419);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPSliderCtrlProxy::Getvalue()
{
	static TAutoDispId _dispId(this, 5420);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setvalue(float arg1)
{
	static TAutoDispId _dispId(this, 5420);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GettoolTip()
{
	static TAutoDispId _dispId(this, 5421);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SettoolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5421);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5422);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5422);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

INT TIWMPSliderCtrlProxy::GetborderSize()
{
	static TAutoDispId _dispId(this, 5423);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetborderSize(INT arg1)
{
	static TAutoDispId _dispId(this, 5423);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPSliderCtrlProxy::GetforegroundHoverImage()
{
	static TAutoDispId _dispId(this, 5424);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetforegroundHoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5424);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPSliderCtrlProxy::GetforegroundProgress()
{
	static TAutoDispId _dispId(this, 5425);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetforegroundProgress(float arg1)
{
	static TAutoDispId _dispId(this, 5425);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPSliderCtrlProxy::GetuseForegroundProgress()
{
	static TAutoDispId _dispId(this, 5426);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSliderCtrlProxy::SetuseForegroundProgress(bool arg1)
{
	static TAutoDispId _dispId(this, 5426);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlEventsProxy::IWMPVideoCtrlEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5720:
			onvideostart();
			break;

		case 5721:
			onvideoend();
			break;
	}
}

HRESULT TIWMPVideoCtrlEventsProxy::onvideostart()
{
	return S_OK;
}

HRESULT TIWMPVideoCtrlEventsProxy::onvideoend()
{
	return S_OK;
}

void TIWMPVideoCtrlProxy::Setwindowless(bool arg1)
{
	static TAutoDispId _dispId(this, 5700);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPVideoCtrlProxy::Getwindowless()
{
	static TAutoDispId _dispId(this, 5700);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5701);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPVideoCtrlProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5701);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5702);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPVideoCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 5702);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SetmaintainAspectRatio(bool arg1)
{
	static TAutoDispId _dispId(this, 5704);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPVideoCtrlProxy::GetmaintainAspectRatio()
{
	static TAutoDispId _dispId(this, 5704);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SettoolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5706);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPVideoCtrlProxy::GettoolTip()
{
	static TAutoDispId _dispId(this, 5706);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPVideoCtrlProxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 5707);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 5707);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SetshrinkToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 5703);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPVideoCtrlProxy::GetshrinkToFit()
{
	static TAutoDispId _dispId(this, 5703);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::SetstretchToFit(bool arg1)
{
	static TAutoDispId _dispId(this, 5708);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPVideoCtrlProxy::GetstretchToFit()
{
	static TAutoDispId _dispId(this, 5708);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoCtrlProxy::Setzoom(long arg1)
{
	static TAutoDispId _dispId(this, 5709);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPVideoCtrlProxy::Getzoom()
{
	static TAutoDispId _dispId(this, 5709);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEffectsCtrlProxy::Getwindowed()
{
	static TAutoDispId _dispId(this, 5500);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::Setwindowed(bool arg1)
{
	static TAutoDispId _dispId(this, 5500);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEffectsCtrlProxy::GetallowAll()
{
	static TAutoDispId _dispId(this, 5501);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::SetallowAll(bool arg1)
{
	static TAutoDispId _dispId(this, 5501);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::SetcurrentEffectType(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5507);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEffectsCtrlProxy::GetcurrentEffectType()
{
	static TAutoDispId _dispId(this, 5507);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPEffectsCtrlProxy::GetcurrentEffectTitle()
{
	static TAutoDispId _dispId(this, 5506);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::next()
{
	static TAutoDispId _dispId(this, 5502);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::previous()
{
	static TAutoDispId _dispId(this, 5503);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::settings()
{
	static TAutoDispId _dispId(this, 5504);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

IDispatch* TIWMPEffectsCtrlProxy::GetcurrentEffect()
{
	static TAutoDispId _dispId(this, 5505);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::SetcurrentEffect(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 5505);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::nextEffect()
{
	static TAutoDispId _dispId(this, 5509);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::previousEffect()
{
	static TAutoDispId _dispId(this, 5510);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::nextPreset()
{
	static TAutoDispId _dispId(this, 5511);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::previousPreset()
{
	static TAutoDispId _dispId(this, 5512);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPEffectsCtrlProxy::GetcurrentPreset()
{
	static TAutoDispId _dispId(this, 5513);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::SetcurrentPreset(long arg1)
{
	static TAutoDispId _dispId(this, 5513);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEffectsCtrlProxy::GetcurrentPresetTitle()
{
	static TAutoDispId _dispId(this, 5514);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEffectsCtrlProxy::GetcurrentEffectPresetCount()
{
	static TAutoDispId _dispId(this, 5515);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEffectsCtrlProxy::GetfullScreen()
{
	static TAutoDispId _dispId(this, 5516);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEffectsCtrlProxy::SetfullScreen(bool arg1)
{
	static TAutoDispId _dispId(this, 5516);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEffectsCtrlProxy::GeteffectCanGoFullScreen()
{
	static TAutoDispId _dispId(this, 5517);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEffectsCtrlProxy::GeteffectHasPropertyPage()
{
	static TAutoDispId _dispId(this, 5518);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEffectsCtrlProxy::GeteffectCount()
{
	static TAutoDispId _dispId(this, 5520);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPEffectsCtrlProxy::GeteffectTitle(long index)
{
	static TAutoDispId _dispId(this, 5521);
	TAutoArgs<1> _args;
	_args[1] = index;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPEffectsCtrlProxy::GeteffectType(long index)
{
	static TAutoDispId _dispId(this, 5522);
	TAutoArgs<1> _args;
	_args[1] = index;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEqualizerSettingsCtrlProxy::Getbypass()
{
	static TAutoDispId _dispId(this, 5800);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::Setbypass(bool arg1)
{
	static TAutoDispId _dispId(this, 5800);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel1()
{
	static TAutoDispId _dispId(this, 5804);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel1(float arg1)
{
	static TAutoDispId _dispId(this, 5804);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel2()
{
	static TAutoDispId _dispId(this, 5805);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel2(float arg1)
{
	static TAutoDispId _dispId(this, 5805);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel3()
{
	static TAutoDispId _dispId(this, 5806);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel3(float arg1)
{
	static TAutoDispId _dispId(this, 5806);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel4()
{
	static TAutoDispId _dispId(this, 5807);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel4(float arg1)
{
	static TAutoDispId _dispId(this, 5807);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel5()
{
	static TAutoDispId _dispId(this, 5808);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel5(float arg1)
{
	static TAutoDispId _dispId(this, 5808);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel6()
{
	static TAutoDispId _dispId(this, 5809);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel6(float arg1)
{
	static TAutoDispId _dispId(this, 5809);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel7()
{
	static TAutoDispId _dispId(this, 5810);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel7(float arg1)
{
	static TAutoDispId _dispId(this, 5810);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel8()
{
	static TAutoDispId _dispId(this, 5811);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel8(float arg1)
{
	static TAutoDispId _dispId(this, 5811);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel9()
{
	static TAutoDispId _dispId(this, 5812);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel9(float arg1)
{
	static TAutoDispId _dispId(this, 5812);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevel10()
{
	static TAutoDispId _dispId(this, 5813);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevel10(float arg1)
{
	static TAutoDispId _dispId(this, 5813);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetgainLevels(long iIndex)
{
	static TAutoDispId _dispId(this, 5815);
	TAutoArgs<1> _args;
	_args[1] = iIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetgainLevels(long iIndex, float arg2)
{
	static TAutoDispId _dispId(this, 5815);
	TAutoArgs<1> _args;
	_args[1] = iIndex;
	_args[0] = arg2;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::reset()
{
	static TAutoDispId _dispId(this, 5814);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::Getbands()
{
	static TAutoDispId _dispId(this, 5801);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::nextPreset()
{
	static TAutoDispId _dispId(this, 5816);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::previousPreset()
{
	static TAutoDispId _dispId(this, 5817);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GetcurrentPreset()
{
	static TAutoDispId _dispId(this, 5818);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetcurrentPreset(long arg1)
{
	static TAutoDispId _dispId(this, 5818);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEqualizerSettingsCtrlProxy::GetcurrentPresetTitle()
{
	static TAutoDispId _dispId(this, 5819);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GetpresetCount()
{
	static TAutoDispId _dispId(this, 5820);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEqualizerSettingsCtrlProxy::GetenhancedAudio()
{
	static TAutoDispId _dispId(this, 5821);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetenhancedAudio(bool arg1)
{
	static TAutoDispId _dispId(this, 5821);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GetspeakerSize()
{
	static TAutoDispId _dispId(this, 5822);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetspeakerSize(long arg1)
{
	static TAutoDispId _dispId(this, 5822);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEqualizerSettingsCtrlProxy::GetcurrentSpeakerName()
{
	static TAutoDispId _dispId(this, 5823);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GettruBassLevel()
{
	static TAutoDispId _dispId(this, 5824);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SettruBassLevel(long arg1)
{
	static TAutoDispId _dispId(this, 5824);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GetwowLevel()
{
	static TAutoDispId _dispId(this, 5825);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetwowLevel(long arg1)
{
	static TAutoDispId _dispId(this, 5825);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetsplineTension()
{
	static TAutoDispId _dispId(this, 5827);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetsplineTension(float arg1)
{
	static TAutoDispId _dispId(this, 5827);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEqualizerSettingsCtrlProxy::GetenableSplineTension()
{
	static TAutoDispId _dispId(this, 5826);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetenableSplineTension(bool arg1)
{
	static TAutoDispId _dispId(this, 5826);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEqualizerSettingsCtrlProxy::GetpresetTitle(long iIndex)
{
	static TAutoDispId _dispId(this, 5828);
	TAutoArgs<1> _args;
	_args[1] = iIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEqualizerSettingsCtrlProxy::Getnormalization()
{
	static TAutoDispId _dispId(this, 5829);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::Setnormalization(bool arg1)
{
	static TAutoDispId _dispId(this, 5829);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetnormalizationAverage()
{
	static TAutoDispId _dispId(this, 5830);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

float TIWMPEqualizerSettingsCtrlProxy::GetnormalizationPeak()
{
	static TAutoDispId _dispId(this, 5831);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPEqualizerSettingsCtrlProxy::GetcrossFade()
{
	static TAutoDispId _dispId(this, 5832);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetcrossFade(bool arg1)
{
	static TAutoDispId _dispId(this, 5832);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEqualizerSettingsCtrlProxy::GetcrossFadeWindow()
{
	static TAutoDispId _dispId(this, 5833);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEqualizerSettingsCtrlProxy::SetcrossFadeWindow(long arg1)
{
	static TAutoDispId _dispId(this, 5833);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPVideoSettingsCtrlProxy::Getbrightness()
{
	static TAutoDispId _dispId(this, 5900);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoSettingsCtrlProxy::Setbrightness(long arg1)
{
	static TAutoDispId _dispId(this, 5900);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPVideoSettingsCtrlProxy::Getcontrast()
{
	static TAutoDispId _dispId(this, 5901);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoSettingsCtrlProxy::Setcontrast(long arg1)
{
	static TAutoDispId _dispId(this, 5901);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPVideoSettingsCtrlProxy::Gethue()
{
	static TAutoDispId _dispId(this, 5902);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoSettingsCtrlProxy::Sethue(long arg1)
{
	static TAutoDispId _dispId(this, 5902);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPVideoSettingsCtrlProxy::Getsaturation()
{
	static TAutoDispId _dispId(this, 5903);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPVideoSettingsCtrlProxy::Setsaturation(long arg1)
{
	static TAutoDispId _dispId(this, 5903);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPVideoSettingsCtrlProxy::reset()
{
	static TAutoDispId _dispId(this, 5904);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPLibraryTreeCtrlProxy::GetdropDownVisible()
{
	static TAutoDispId _dispId(this, 6401);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetdropDownVisible(bool arg1)
{
	static TAutoDispId _dispId(this, 6401);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 6402);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6402);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 6403);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6403);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPLibraryTreeCtrlProxy::GetfontSize()
{
	static TAutoDispId _dispId(this, 6404);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetfontSize(long arg1)
{
	static TAutoDispId _dispId(this, 6404);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::GetfontStyle()
{
	static TAutoDispId _dispId(this, 6405);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetfontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6405);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::GetfontFace()
{
	static TAutoDispId _dispId(this, 6406);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetfontFace(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6406);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::Getfilter()
{
	static TAutoDispId _dispId(this, 6407);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::Setfilter(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6407);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPLibraryTreeCtrlProxy::GetexpandState()
{
	static TAutoDispId _dispId(this, 6408);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::SetexpandState(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6408);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::GetPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 6409);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPLibraryTreeCtrlProxy::SetPlaylist(IWMPPlaylist* arg1)
{
	static TAutoDispId _dispId(this, 6409);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPLibraryTreeCtrlProxy::GetselectedPlaylist(TIWMPPlaylistProxy& object)
{
	static TAutoDispId _dispId(this, 6410);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

void TIWMPLibraryTreeCtrlProxy::GetselectedMedia(TIWMPMediaProxy& object)
{
	static TAutoDispId _dispId(this, 6411);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPEditCtrlProxy::Getvalue()
{
	static TAutoDispId _dispId(this, (long)0);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::Setvalue(TAutoString arg1)
{
	static TAutoDispId _dispId(this, (long)0);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEditCtrlProxy::Getborder()
{
	static TAutoDispId _dispId(this, 6000);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::Setborder(bool arg1)
{
	static TAutoDispId _dispId(this, 6000);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::Getjustification()
{
	static TAutoDispId _dispId(this, 6001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::Setjustification(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6001);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::GeteditStyle()
{
	static TAutoDispId _dispId(this, 6002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SeteditStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEditCtrlProxy::GetwordWrap()
{
	static TAutoDispId _dispId(this, 6003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetwordWrap(bool arg1)
{
	static TAutoDispId _dispId(this, 6003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPEditCtrlProxy::GetreadOnly()
{
	static TAutoDispId _dispId(this, 6004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetreadOnly(bool arg1)
{
	static TAutoDispId _dispId(this, 6004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 6005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 6006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::GetfontSize()
{
	static TAutoDispId _dispId(this, 6007);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetfontSize(long arg1)
{
	static TAutoDispId _dispId(this, 6007);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::GetfontStyle()
{
	static TAutoDispId _dispId(this, 6008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetfontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::GetfontFace()
{
	static TAutoDispId _dispId(this, 6009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SetfontFace(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::GettextLimit()
{
	static TAutoDispId _dispId(this, 6010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::SettextLimit(long arg1)
{
	static TAutoDispId _dispId(this, 6010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::GetlineCount()
{
	static TAutoDispId _dispId(this, 6011);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPEditCtrlProxy::getLine(long nIndex)
{
	static TAutoDispId _dispId(this, 6012);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::getSelectionStart()
{
	static TAutoDispId _dispId(this, 6013);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::getSelectionEnd()
{
	static TAutoDispId _dispId(this, 6014);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::setSelection(long nStart, long nEnd)
{
	static TAutoDispId _dispId(this, 6015);
	TAutoArgs<2> _args;
	_args[1] = nStart;
	_args[2] = nEnd;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPEditCtrlProxy::replaceSelection(TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6016);
	TAutoArgs<1> _args;
	_args[1] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::getLineIndex(long nIndex)
{
	static TAutoDispId _dispId(this, 6017);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

long TIWMPEditCtrlProxy::getLineFromChar(long nPosition)
{
	static TAutoDispId _dispId(this, 6018);
	TAutoArgs<1> _args;
	_args[1] = nPosition;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

TAutoString TIWMPPluginUIHostProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 6201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPluginUIHostProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6201);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPPluginUIHostProxy::GetobjectID()
{
	static TAutoDispId _dispId(this, 6202);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPPluginUIHostProxy::SetobjectID(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 6202);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoVal TIWMPPluginUIHostProxy::getProperty(TAutoString bstrName)
{
	static TAutoDispId _dispId(this, 6203);
	TAutoArgs<1> _args;
	_args[1] = bstrName;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPPluginUIHostProxy::setProperty(TAutoString bstrName, TAutoVal newVal)
{
	static TAutoDispId _dispId(this, 6204);
	TAutoArgs<2> _args;
	_args[1] = bstrName;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::deleteAllItems()
{
	static TAutoDispId _dispId(this, 6301);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::appendItem(long nID, TAutoString bstrItem)
{
	static TAutoDispId _dispId(this, 6302);
	TAutoArgs<2> _args;
	_args[1] = nID;
	_args[2] = bstrItem;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::appendSeparator()
{
	static TAutoDispId _dispId(this, 6303);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::enableItem(long nID, bool newVal)
{
	static TAutoDispId _dispId(this, 6304);
	TAutoArgs<2> _args;
	_args[1] = nID;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::checkItem(long nID, bool newVal)
{
	static TAutoDispId _dispId(this, 6305);
	TAutoArgs<2> _args;
	_args[1] = nID;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::checkRadioItem(long nID, bool newVal)
{
	static TAutoDispId _dispId(this, 6306);
	TAutoArgs<2> _args;
	_args[1] = nID;
	_args[2] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPMenuCtrlProxy::GetshowFlags()
{
	static TAutoDispId _dispId(this, 6307);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::SetshowFlags(long arg1)
{
	static TAutoDispId _dispId(this, 6307);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPMenuCtrlProxy::show()
{
	static TAutoDispId _dispId(this, 6308);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPMenuCtrlProxy::showEx(long nID)
{
	static TAutoDispId _dispId(this, 6309);
	TAutoArgs<1> _args;
	_args[1] = nID;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPAutoMenuCtrlProxy::show(TAutoString newVal)
{
	static TAutoDispId _dispId(this, 6501);
	TAutoArgs<1> _args;
	_args[1] = newVal;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::Getimage()
{
	static TAutoDispId _dispId(this, 5300);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::Setimage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5300);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GethoverImage()
{
	static TAutoDispId _dispId(this, 5301);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SethoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5301);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GetdownImage()
{
	static TAutoDispId _dispId(this, 5302);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SetdownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5302);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GethoverDownImage()
{
	static TAutoDispId _dispId(this, 5303);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SethoverDownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5303);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GetdisabledImage()
{
	static TAutoDispId _dispId(this, 5304);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SetdisabledImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5304);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GetmappingImage()
{
	static TAutoDispId _dispId(this, 5305);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SetmappingImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5305);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 5306);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5306);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonCtrlProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5308);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5308);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonCtrlProxy::GetshowBackground()
{
	static TAutoDispId _dispId(this, 5309);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SetshowBackground(bool arg1)
{
	static TAutoDispId _dispId(this, 5309);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonCtrlProxy::Getradio()
{
	static TAutoDispId _dispId(this, 5310);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::Setradio(bool arg1)
{
	static TAutoDispId _dispId(this, 5310);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPRegionalButtonCtrlProxy::GetbuttonCount()
{
	static TAutoDispId _dispId(this, 5311);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

IDispatch* TIWMPRegionalButtonCtrlProxy::createButton()
{
	static TAutoDispId _dispId(this, 5312);
	TAutoArgs<0> _args;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

IDispatch* TIWMPRegionalButtonCtrlProxy::getButton(long nButton)
{
	static TAutoDispId _dispId(this, 5313);
	TAutoArgs<1> _args;
	_args[1] = nButton;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::Click(long nButton)
{
	static TAutoDispId _dispId(this, 5314);
	TAutoArgs<1> _args;
	_args[1] = nButton;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

float TIWMPRegionalButtonCtrlProxy::GethueShift()
{
	static TAutoDispId _dispId(this, 5315);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::SethueShift(float arg1)
{
	static TAutoDispId _dispId(this, 5315);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPRegionalButtonCtrlProxy::Getsaturation()
{
	static TAutoDispId _dispId(this, 5316);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonCtrlProxy::Setsaturation(float arg1)
{
	static TAutoDispId _dispId(this, 5316);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonEventsProxy::IWMPRegionalButtonEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5360:
			onblur();
			break;

		case 5361:
			onfocus();
			break;

		case 5362:
			onclick();
			break;

		case 5363:
			ondblclick();
			break;

		case 5364:
			onmousedown();
			break;

		case 5365:
			onmouseup();
			break;

		case 5366:
			onmousemove();
			break;

		case 5367:
			onmouseover();
			break;

		case 5368:
			onmouseout();
			break;

		case 5369:
			onkeypress();
			break;

		case 5370:
			onkeydown();
			break;

		case 5371:
			onkeyup();
			break;
	}
}

HRESULT TIWMPRegionalButtonEventsProxy::onblur()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onfocus()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onclick()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::ondblclick()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onmousedown()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onmouseup()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onmousemove()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onmouseover()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onmouseout()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onkeypress()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onkeydown()
{
	return S_OK;
}

HRESULT TIWMPRegionalButtonEventsProxy::onkeyup()
{
	return S_OK;
}

TAutoString TIWMPRegionalButtonProxy::GetupToolTip()
{
	static TAutoDispId _dispId(this, 5330);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetupToolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5330);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::GetdownToolTip()
{
	static TAutoDispId _dispId(this, 5331);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetdownToolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5331);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::GetmappingColor()
{
	static TAutoDispId _dispId(this, 5332);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetmappingColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5332);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonProxy::Getenabled()
{
	static TAutoDispId _dispId(this, 5333);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::Setenabled(bool arg1)
{
	static TAutoDispId _dispId(this, 5333);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonProxy::Getsticky()
{
	static TAutoDispId _dispId(this, 5339);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::Setsticky(bool arg1)
{
	static TAutoDispId _dispId(this, 5339);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonProxy::Getdown()
{
	static TAutoDispId _dispId(this, 5340);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::Setdown(bool arg1)
{
	static TAutoDispId _dispId(this, 5340);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPRegionalButtonProxy::Getindex()
{
	static TAutoDispId _dispId(this, 5341);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

bool TIWMPRegionalButtonProxy::GettabStop()
{
	static TAutoDispId _dispId(this, 5342);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SettabStop(bool arg1)
{
	static TAutoDispId _dispId(this, 5342);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5343);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5343);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::Click()
{
	static TAutoDispId _dispId(this, 5344);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::GetaccName()
{
	static TAutoDispId _dispId(this, 5345);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetaccName(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5345);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::GetaccDescription()
{
	static TAutoDispId _dispId(this, 5346);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetaccDescription(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5346);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPRegionalButtonProxy::GetaccKeyboardShortcut()
{
	static TAutoDispId _dispId(this, 5347);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPRegionalButtonProxy::SetaccKeyboardShortcut(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5347);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderCtrlEventsProxy::IWMPCustomSliderCtrlEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5020:
			ondragbegin();
			break;

		case 5021:
			ondragend();
			break;

		case 5022:
			onpositionchange();
			break;
	}
}

HRESULT TIWMPCustomSliderCtrlEventsProxy::ondragbegin()
{
	return S_OK;
}

HRESULT TIWMPCustomSliderCtrlEventsProxy::ondragend()
{
	return S_OK;
}

HRESULT TIWMPCustomSliderCtrlEventsProxy::onpositionchange()
{
	return S_OK;
}

TAutoString TIWMPCustomSliderProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPCustomSliderProxy::Getmin()
{
	static TAutoDispId _dispId(this, 5005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::Setmin(float arg1)
{
	static TAutoDispId _dispId(this, 5005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPCustomSliderProxy::Getmax()
{
	static TAutoDispId _dispId(this, 5006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::Setmax(float arg1)
{
	static TAutoDispId _dispId(this, 5006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIWMPCustomSliderProxy::Getvalue()
{
	static TAutoDispId _dispId(this, 5010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::Setvalue(float arg1)
{
	static TAutoDispId _dispId(this, 5010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GettoolTip()
{
	static TAutoDispId _dispId(this, 5011);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SettoolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5011);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GetpositionImage()
{
	static TAutoDispId _dispId(this, 5002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SetpositionImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::Getimage()
{
	static TAutoDispId _dispId(this, 5001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::Setimage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5001);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GethoverImage()
{
	static TAutoDispId _dispId(this, 5003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SethoverImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GetdisabledImage()
{
	static TAutoDispId _dispId(this, 5004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SetdisabledImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GetdownImage()
{
	static TAutoDispId _dispId(this, 5012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SetdownImage(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5012);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCustomSliderProxy::GettransparencyColor()
{
	static TAutoDispId _dispId(this, 5008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCustomSliderProxy::SettransparencyColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 5201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5201);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetfontFace()
{
	static TAutoDispId _dispId(this, 5206);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetfontFace(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5206);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetfontStyle()
{
	static TAutoDispId _dispId(this, 5207);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetfontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5207);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIWMPTextCtrlProxy::GetfontSize()
{
	static TAutoDispId _dispId(this, 5208);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetfontSize(long arg1)
{
	static TAutoDispId _dispId(this, 5208);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 5209);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5209);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GethoverBackgroundColor()
{
	static TAutoDispId _dispId(this, 5210);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SethoverBackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5210);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GethoverForegroundColor()
{
	static TAutoDispId _dispId(this, 5211);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SethoverForegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5211);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GethoverFontStyle()
{
	static TAutoDispId _dispId(this, 5212);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SethoverFontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5212);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::Getvalue()
{
	static TAutoDispId _dispId(this, 5213);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::Setvalue(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5213);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GettoolTip()
{
	static TAutoDispId _dispId(this, 5214);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SettoolTip(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5214);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetdisabledFontStyle()
{
	static TAutoDispId _dispId(this, 5215);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetdisabledFontStyle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5215);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetdisabledForegroundColor()
{
	static TAutoDispId _dispId(this, 5216);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetdisabledForegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5216);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetdisabledBackgroundColor()
{
	static TAutoDispId _dispId(this, 5217);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetdisabledBackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5217);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPTextCtrlProxy::GetfontSmoothing()
{
	static TAutoDispId _dispId(this, 5221);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetfontSmoothing(bool arg1)
{
	static TAutoDispId _dispId(this, 5221);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::Getjustification()
{
	static TAutoDispId _dispId(this, 5222);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::Setjustification(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5222);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPTextCtrlProxy::GetwordWrap()
{
	static TAutoDispId _dispId(this, 5223);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetwordWrap(bool arg1)
{
	static TAutoDispId _dispId(this, 5223);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::Getcursor()
{
	static TAutoDispId _dispId(this, 5224);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::Setcursor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5224);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIWMPTextCtrlProxy::Getscrolling()
{
	static TAutoDispId _dispId(this, 5225);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::Setscrolling(bool arg1)
{
	static TAutoDispId _dispId(this, 5225);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTextCtrlProxy::GetscrollingDirection()
{
	static TAutoDispId _dispId(this, 5226);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetscrollingDirection(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 5226);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

INT TIWMPTextCtrlProxy::GetscrollingDelay()
{
	static TAutoDispId _dispId(this, 5227);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetscrollingDelay(INT arg1)
{
	static TAutoDispId _dispId(this, 5227);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

INT TIWMPTextCtrlProxy::GetscrollingAmount()
{
	static TAutoDispId _dispId(this, 5228);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTextCtrlProxy::SetscrollingAmount(INT arg1)
{
	static TAutoDispId _dispId(this, 5228);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

INT TIWMPTextCtrlProxy::GettextWidth()
{
	static TAutoDispId _dispId(this, 5229);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

IUnknown* TITaskCntrCtrlProxy::GetCurrentContainer()
{
	static TAutoDispId _dispId(this, 1610743808);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TITaskCntrCtrlProxy::SetCurrentContainer(IUnknown* arg1)
{
	static TAutoDispId _dispId(this, 1610743808);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TITaskCntrCtrlProxy::Activate()
{
	static TAutoDispId _dispId(this, 1610743810);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void T_WMPCoreEventsProxy::_WMPCoreEvents_Handler(TAutoStack& Args)
{
	switch (Args.DispId) {
		case 5001:
			OpenStateChange(Args[0]);
			break;

		case 5101:
			PlayStateChange(Args[0]);
			break;

		case 5102:
			AudioLanguageChange(Args[0]);
			break;

		case 5002:
			StatusChange();
			break;

		case 5301:
			ScriptCommand(Args[0], Args[1]);
			break;

		case 5403:
			NewStream();
			break;

		case 5401:
			Disconnect(Args[0]);
			break;

		case 5402:
			Buffering(Args[0]);
			break;

		case 5501:
			Error();
			break;

		case 5601:
			Warning(Args[0], Args[1], Args[2]);
			break;

		case 5201:
			EndOfStream(Args[0]);
			break;

		case 5202:
			PositionChange(Args[0], Args[1]);
			break;

		case 5203:
			MarkerHit(Args[0]);
			break;

		case 5204:
			DurationUnitChange(Args[0]);
			break;

		case 5701:
			CdromMediaChange(Args[0]);
			break;

		case 5801:
			PlaylistChange(Args[0], (WMPPlaylistChangeEventType)(int)Args[1]);
			break;

		case 5804:
			CurrentPlaylistChange((WMPPlaylistChangeEventType)(int)Args[0]);
			break;

		case 5805:
			CurrentPlaylistItemAvailable(Args[0]);
			break;

		case 5802:
			MediaChange(Args[0]);
			break;

		case 5803:
			CurrentMediaItemAvailable(Args[0]);
			break;

		case 5806:
			CurrentItemChange(Args[0]);
			break;

		case 5807:
			MediaCollectionChange();
			break;

		case 5808:
			MediaCollectionAttributeStringAdded(Args[0], Args[1]);
			break;

		case 5809:
			MediaCollectionAttributeStringRemoved(Args[0], Args[1]);
			break;

		case 5820:
			MediaCollectionAttributeStringChanged(Args[0], Args[1], Args[2]);
			break;

		case 5810:
			PlaylistCollectionChange();
			break;

		case 5811:
			PlaylistCollectionPlaylistAdded(Args[0]);
			break;

		case 5812:
			PlaylistCollectionPlaylistRemoved(Args[0]);
			break;

		case 5818:
			PlaylistCollectionPlaylistSetAsDeleted(Args[0], Args[1]);
			break;

		case 5819:
			ModeChange(Args[0], Args[1]);
			break;

		case 5821:
			MediaError(Args[0]);
			break;

		case 5823:
			OpenPlaylistSwitch(Args[0]);
			break;

		case 5822:
			DomainChange(Args[0]);
			break;
	}
}

void T_WMPCoreEventsProxy::OpenStateChange(long /* NewState */)
{
}

void T_WMPCoreEventsProxy::PlayStateChange(long /* NewState */)
{
}

void T_WMPCoreEventsProxy::AudioLanguageChange(long /* LangID */)
{
}

void T_WMPCoreEventsProxy::StatusChange()
{
}

void T_WMPCoreEventsProxy::ScriptCommand(TAutoString /* scType */, TAutoString /* Param */)
{
}

void T_WMPCoreEventsProxy::NewStream()
{
}

void T_WMPCoreEventsProxy::Disconnect(long /* Result */)
{
}

void T_WMPCoreEventsProxy::Buffering(bool /* Start */)
{
}

void T_WMPCoreEventsProxy::Error()
{
}

void T_WMPCoreEventsProxy::Warning(long /* WarningType */, long /* Param */, TAutoString /* Description */)
{
}

void T_WMPCoreEventsProxy::EndOfStream(long /* Result */)
{
}

void T_WMPCoreEventsProxy::PositionChange(double /* oldPosition */, double /* newPosition */)
{
}

void T_WMPCoreEventsProxy::MarkerHit(long /* MarkerNum */)
{
}

void T_WMPCoreEventsProxy::DurationUnitChange(long /* NewDurationUnit */)
{
}

void T_WMPCoreEventsProxy::CdromMediaChange(long /* CdromNum */)
{
}

void T_WMPCoreEventsProxy::PlaylistChange(IDispatch* /* Playlist */, WMPPlaylistChangeEventType /* change */)
{
}

void T_WMPCoreEventsProxy::CurrentPlaylistChange(WMPPlaylistChangeEventType /* change */)
{
}

void T_WMPCoreEventsProxy::CurrentPlaylistItemAvailable(TAutoString /* bstrItemName */)
{
}

void T_WMPCoreEventsProxy::MediaChange(IDispatch* /* Item */)
{
}

void T_WMPCoreEventsProxy::CurrentMediaItemAvailable(TAutoString /* bstrItemName */)
{
}

void T_WMPCoreEventsProxy::CurrentItemChange(IDispatch* /* pdispMedia */)
{
}

void T_WMPCoreEventsProxy::MediaCollectionChange()
{
}

void T_WMPCoreEventsProxy::MediaCollectionAttributeStringAdded(TAutoString /* bstrAttribName */, TAutoString /* bstrAttribVal */)
{
}

void T_WMPCoreEventsProxy::MediaCollectionAttributeStringRemoved(TAutoString /* bstrAttribName */, TAutoString /* bstrAttribVal */)
{
}

void T_WMPCoreEventsProxy::MediaCollectionAttributeStringChanged(TAutoString /* bstrAttribName */, TAutoString /* bstrOldAttribVal */, TAutoString /* bstrNewAttribVal */)
{
}

void T_WMPCoreEventsProxy::PlaylistCollectionChange()
{
}

void T_WMPCoreEventsProxy::PlaylistCollectionPlaylistAdded(TAutoString /* bstrPlaylistName */)
{
}

void T_WMPCoreEventsProxy::PlaylistCollectionPlaylistRemoved(TAutoString /* bstrPlaylistName */)
{
}

void T_WMPCoreEventsProxy::PlaylistCollectionPlaylistSetAsDeleted(TAutoString /* bstrPlaylistName */, bool /* varfIsDeleted */)
{
}

void T_WMPCoreEventsProxy::ModeChange(TAutoString /* ModeName */, bool /* NewValue */)
{
}

void T_WMPCoreEventsProxy::MediaError(IDispatch* /* pMediaObject */)
{
}

void T_WMPCoreEventsProxy::OpenPlaylistSwitch(IDispatch* /* pItem */)
{
}

void T_WMPCoreEventsProxy::DomainChange(TAutoString /* strDomain */)
{
}

void TIWMPGraphEventHandlerProxy::NotifyGraphStateChange(ULONG_PTR punkGraph, long lGraphState)
{
	static TAutoDispId _dispId(this, 8151);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = lGraphState;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::AsyncNotifyGraphStateChange(ULONG_PTR punkGraph, long lGraphState)
{
	static TAutoDispId _dispId(this, 8173);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = lGraphState;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyRateChange(ULONG_PTR punkGraph, double dRate)
{
	static TAutoDispId _dispId(this, 8153);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = dRate;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyPlaybackEnd(ULONG_PTR punkGraph, TAutoString bstrQueuedUrl, unsigned long dwCurrentContext)
{
	static TAutoDispId _dispId(this, 8157);
	TAutoArgs<3> _args;
	_args[1] = punkGraph;
	_args[2] = bstrQueuedUrl;
	_args[3] = dwCurrentContext;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyStreamEnd(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8156);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyScriptCommand(ULONG_PTR punkGraph, TAutoString bstrCommand, TAutoString bstrParam)
{
	static TAutoDispId _dispId(this, 8158);
	TAutoArgs<3> _args;
	_args[1] = punkGraph;
	_args[2] = bstrCommand;
	_args[3] = bstrParam;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyEarlyScriptCommand(ULONG_PTR punkGraph, TAutoString bstrCommand, TAutoString bstrParam, double dTime)
{
	static TAutoDispId _dispId(this, 8172);
	TAutoArgs<4> _args;
	_args[1] = punkGraph;
	_args[2] = bstrCommand;
	_args[3] = bstrParam;
	_args[4] = dTime;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyMarkerHit(ULONG_PTR punkGraph, long lMarker)
{
	static TAutoDispId _dispId(this, 8159);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = lMarker;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyGraphError(ULONG_PTR punkGraph, long lErrMajor, long lErrMinor, long lCondition, TAutoString bstrInfo)
{
	static TAutoDispId _dispId(this, 8160);
	TAutoArgs<5> _args;
	_args[1] = punkGraph;
	_args[2] = lErrMajor;
	_args[3] = lErrMinor;
	_args[4] = lCondition;
	_args[5] = bstrInfo;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyAcquireCredentials(ULONG_PTR punkGraph, TAutoString bstrRealm, TAutoString bstrSite, TAutoString bstrUser, TAutoString bstrPassword, unsigned long* pdwFlags, bool* pfCancel)
{
	static TAutoDispId _dispId(this, 8161);
	TAutoArgs<7> _args;
	_args[1] = punkGraph;
	_args[2] = bstrRealm;
	_args[3] = bstrSite;
	_args[4] = bstrUser;
	_args[5] = bstrPassword;
	_args[6] = pdwFlags;
	_args[7] = pfCancel;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyUntrustedLicense(ULONG_PTR punkGraph, TAutoString bstrURL, bool* pfCancel)
{
	static TAutoDispId _dispId(this, 8178);
	TAutoArgs<3> _args;
	_args[1] = punkGraph;
	_args[2] = bstrURL;
	_args[3] = pfCancel;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyLicenseDialog(ULONG_PTR punkGraph, TAutoString bstrURL, unsigned char* pPostData, unsigned long dwPostDataSize, long lResult)
{
	static TAutoDispId _dispId(this, 8162);
	TAutoArgs<5> _args;
	_args[1] = punkGraph;
	_args[2] = bstrURL;
	_args[3] = pPostData;
	_args[4] = dwPostDataSize;
	_args[5] = lResult;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyNeedsIndividualization(ULONG_PTR punkGraph, bool* pfResult)
{
	static TAutoDispId _dispId(this, 8163);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = pfResult;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyNewMetadata(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8165);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyNewMediaCaps(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8166);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyDisconnect(ULONG_PTR punkGraph, long lResult)
{
	static TAutoDispId _dispId(this, 8167);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = lResult;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifySave(ULONG_PTR punkGraph, long fStarted, long lResult)
{
	static TAutoDispId _dispId(this, 8168);
	TAutoArgs<3> _args;
	_args[1] = punkGraph;
	_args[2] = fStarted;
	_args[3] = lResult;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyDelayClose(ULONG_PTR punkGraph, bool fDelay)
{
	static TAutoDispId _dispId(this, 8169);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = fDelay;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyDVD(ULONG_PTR punkGraph, long lEventCode, long lParam1, long lParam2)
{
	static TAutoDispId _dispId(this, 8170);
	TAutoArgs<4> _args;
	_args[1] = punkGraph;
	_args[2] = lEventCode;
	_args[3] = lParam1;
	_args[4] = lParam2;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyRequestAppThreadAction(ULONG_PTR punkGraph, unsigned long dwAction)
{
	static TAutoDispId _dispId(this, 8171);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = dwAction;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyPrerollReady(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8174);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyNewIcons(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8177);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyStepComplete(ULONG_PTR punkGraph)
{
	static TAutoDispId _dispId(this, 8179);
	TAutoArgs<1> _args;
	_args[1] = punkGraph;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPGraphEventHandlerProxy::NotifyNewBitrate(ULONG_PTR punkGraph, unsigned long dwBitrate)
{
	static TAutoDispId _dispId(this, 8180);
	TAutoArgs<2> _args;
	_args[1] = punkGraph;
	_args[2] = dwBitrate;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIBatteryProxy::GetpresetCount()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

IDispatch* TIBatteryProxy::Getpreset(long nIndex)
{
	static TAutoDispId _dispId(this, 2);
	TAutoArgs<1> _args;
	_args[1] = nIndex;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIBatteryPresetProxy::Gettitle()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBatteryPresetProxy::Settitle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIBatteryRandomPresetProxy::Gettitle()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBatteryRandomPresetProxy::Settitle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIBatterySavedPresetProxy::Gettitle()
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBatterySavedPresetProxy::Settitle(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 1);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GetdisplayMode()
{
	static TAutoDispId _dispId(this, 8000);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetdisplayMode(long arg1)
{
	static TAutoDispId _dispId(this, 8000);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIBarsEffectProxy::GetshowPeaks()
{
	static TAutoDispId _dispId(this, 8001);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetshowPeaks(bool arg1)
{
	static TAutoDispId _dispId(this, 8001);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GetpeakHangTime()
{
	static TAutoDispId _dispId(this, 8002);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetpeakHangTime(long arg1)
{
	static TAutoDispId _dispId(this, 8002);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIBarsEffectProxy::GetpeakFallbackAcceleration()
{
	static TAutoDispId _dispId(this, 8003);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetpeakFallbackAcceleration(float arg1)
{
	static TAutoDispId _dispId(this, 8003);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIBarsEffectProxy::GetpeakFallbackSpeed()
{
	static TAutoDispId _dispId(this, 8004);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetpeakFallbackSpeed(float arg1)
{
	static TAutoDispId _dispId(this, 8004);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIBarsEffectProxy::GetlevelFallbackAcceleration()
{
	static TAutoDispId _dispId(this, 8005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetlevelFallbackAcceleration(float arg1)
{
	static TAutoDispId _dispId(this, 8005);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIBarsEffectProxy::GetlevelFallbackSpeed()
{
	static TAutoDispId _dispId(this, 8006);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetlevelFallbackSpeed(float arg1)
{
	static TAutoDispId _dispId(this, 8006);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIBarsEffectProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 8007);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8007);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIBarsEffectProxy::GetlevelColor()
{
	static TAutoDispId _dispId(this, 8008);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetlevelColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8008);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIBarsEffectProxy::GetpeakColor()
{
	static TAutoDispId _dispId(this, 8009);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetpeakColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8009);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GethorizontalSpacing()
{
	static TAutoDispId _dispId(this, 8010);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SethorizontalSpacing(long arg1)
{
	static TAutoDispId _dispId(this, 8010);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GetlevelWidth()
{
	static TAutoDispId _dispId(this, 8012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetlevelWidth(long arg1)
{
	static TAutoDispId _dispId(this, 8012);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIBarsEffectProxy::GetlevelScale()
{
	static TAutoDispId _dispId(this, 8013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetlevelScale(float arg1)
{
	static TAutoDispId _dispId(this, 8013);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GetfadeRate()
{
	static TAutoDispId _dispId(this, 8014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetfadeRate(long arg1)
{
	static TAutoDispId _dispId(this, 8014);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TIBarsEffectProxy::GetfadeMode()
{
	static TAutoDispId _dispId(this, 8015);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::SetfadeMode(long arg1)
{
	static TAutoDispId _dispId(this, 8015);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIBarsEffectProxy::Gettransparent()
{
	static TAutoDispId _dispId(this, 8016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIBarsEffectProxy::Settransparent(bool arg1)
{
	static TAutoDispId _dispId(this, 8016);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TISpikesEffectProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 8201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TISpikesEffectProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8201);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TISpikesEffectProxy::GetforegroundColor()
{
	static TAutoDispId _dispId(this, 8202);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TISpikesEffectProxy::SetforegroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8202);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

long TISpikesEffectProxy::GetdisplayMode()
{
	static TAutoDispId _dispId(this, 8203);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TISpikesEffectProxy::SetdisplayMode(long arg1)
{
	static TAutoDispId _dispId(this, 8203);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TISpikesEffectProxy::GetfallbackSpeed()
{
	static TAutoDispId _dispId(this, 8204);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TISpikesEffectProxy::SetfallbackSpeed(float arg1)
{
	static TAutoDispId _dispId(this, 8204);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TISpikesEffectProxy::Gettransparent()
{
	static TAutoDispId _dispId(this, 8205);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TISpikesEffectProxy::Settransparent(bool arg1)
{
	static TAutoDispId _dispId(this, 8205);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIDotPlaneEffectProxy::GetcameraDistance()
{
	static TAutoDispId _dispId(this, 8300);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetcameraDistance(float arg1)
{
	static TAutoDispId _dispId(this, 8300);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIDotPlaneEffectProxy::GetfallbackAcceleration()
{
	static TAutoDispId _dispId(this, 8301);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfallbackAcceleration(float arg1)
{
	static TAutoDispId _dispId(this, 8301);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

float TIDotPlaneEffectProxy::GetfallbackSpeed()
{
	static TAutoDispId _dispId(this, 8302);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfallbackSpeed(float arg1)
{
	static TAutoDispId _dispId(this, 8302);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIDotPlaneEffectProxy::GetspinZ()
{
	static TAutoDispId _dispId(this, 8303);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetspinZ(bool arg1)
{
	static TAutoDispId _dispId(this, 8303);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIDotPlaneEffectProxy::GetspinX()
{
	static TAutoDispId _dispId(this, 8304);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetspinX(bool arg1)
{
	static TAutoDispId _dispId(this, 8304);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIDotPlaneEffectProxy::GetspinY()
{
	static TAutoDispId _dispId(this, 8305);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetspinY(bool arg1)
{
	static TAutoDispId _dispId(this, 8305);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::reset()
{
	static TAutoDispId _dispId(this, 8313);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::stopSpin()
{
	static TAutoDispId _dispId(this, 8314);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetbackgroundColor()
{
	static TAutoDispId _dispId(this, 8307);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetbackgroundColor(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8307);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetfadeColor1()
{
	static TAutoDispId _dispId(this, 8308);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfadeColor1(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8308);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetfadeColor2()
{
	static TAutoDispId _dispId(this, 8309);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfadeColor2(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8309);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetfadeColor3()
{
	static TAutoDispId _dispId(this, 8310);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfadeColor3(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8310);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetfadeColor4()
{
	static TAutoDispId _dispId(this, 8311);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfadeColor4(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8311);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIDotPlaneEffectProxy::GetfadeColor5()
{
	static TAutoDispId _dispId(this, 8312);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::SetfadeColor5(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 8312);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

bool TIDotPlaneEffectProxy::Gettransparent()
{
	static TAutoDispId _dispId(this, 8315);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIDotPlaneEffectProxy::Settransparent(bool arg1)
{
	static TAutoDispId _dispId(this, 8315);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPExternalColorsProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorMedium()
{
	static TAutoDispId _dispId(this, 10013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorDark()
{
	static TAutoDispId _dispId(this, 10014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorButtonHighlight()
{
	static TAutoDispId _dispId(this, 10015);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorButtonShadow()
{
	static TAutoDispId _dispId(this, 10016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPExternalColorsProxy::GetappColorButtonHoverFace()
{
	static TAutoDispId _dispId(this, 10017);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTemplatesExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorMedium()
{
	static TAutoDispId _dispId(this, 10013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorDark()
{
	static TAutoDispId _dispId(this, 10014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorButtonHighlight()
{
	static TAutoDispId _dispId(this, 10015);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorButtonShadow()
{
	static TAutoDispId _dispId(this, 10016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetappColorButtonHoverFace()
{
	static TAutoDispId _dispId(this, 10017);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTemplatesExternalProxy::EditMetadata()
{
	static TAutoDispId _dispId(this, 10011);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPTemplatesExternalProxy::IsMetadataAvailableForEdit()
{
	static TAutoDispId _dispId(this, 10010);
	TAutoArgs<0> _args;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

bool TIWMPTemplatesExternalProxy::IsAutoMetadataDownloadAllowed()
{
	static TAutoDispId _dispId(this, 10019);
	TAutoArgs<0> _args;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPTemplatesExternalProxy::AdvancedEditDialog()
{
	static TAutoDispId _dispId(this, 10006);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPTemplatesExternalProxy::IsAdvancedEditDialogAvailable()
{
	static TAutoDispId _dispId(this, 10021);
	TAutoArgs<0> _args;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

TAutoString TIWMPTemplatesExternalProxy::GetHueShiftedBitmapURL(long resID)
{
	static TAutoDispId _dispId(this, 10020);
	TAutoArgs<1> _args;
	_args[1] = resID;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTemplatesExternalProxy::FindMedia(TAutoString bstrURLParams)
{
	static TAutoDispId _dispId(this, 10022);
	TAutoArgs<1> _args;
	_args[1] = bstrURLParams;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPTemplatesExternalProxy::BuyCD(TAutoString bstrURLParams)
{
	static TAutoDispId _dispId(this, 10023);
	TAutoArgs<1> _args;
	_args[1] = bstrURLParams;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPTemplatesExternalProxy::GetState()
{
	static TAutoDispId _dispId(this, 10024);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPTemplatesExternalProxy::SetState(TAutoString arg1)
{
	static TAutoDispId _dispId(this, 10024);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPDownloadItemProxy::GetsourceURL()
{
	static TAutoDispId _dispId(this, 1251);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPDownloadItemProxy::Getsize()
{
	static TAutoDispId _dispId(this, 1252);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPDownloadItemProxy::Gettype()
{
	static TAutoDispId _dispId(this, 1253);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPDownloadItemProxy::Getprogress()
{
	static TAutoDispId _dispId(this, 1254);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

WMPSubscriptionDownloadState TIWMPDownloadItemProxy::GetdownloadState()
{
	static TAutoDispId _dispId(this, 1255);
	TAutoArgs<0> _args;
	return (WMPSubscriptionDownloadState)(int)Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPDownloadItemProxy::pause()
{
	static TAutoDispId _dispId(this, 1256);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDownloadItemProxy::resume()
{
	static TAutoDispId _dispId(this, 1257);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDownloadItemProxy::cancel()
{
	static TAutoDispId _dispId(this, 1258);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

long TIWMPDownloadCollectionProxy::Getid()
{
	static TAutoDispId _dispId(this, 1201);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

long TIWMPDownloadCollectionProxy::Getcount()
{
	static TAutoDispId _dispId(this, 1202);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPDownloadCollectionProxy::Item(TIWMPDownloadItemProxy& object, long lItem)
{
	static TAutoDispId _dispId(this, 1203);
	TAutoArgs<1> _args;
	_args[1] = lItem;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPDownloadCollectionProxy::startDownload(TIWMPDownloadItemProxy& object, TAutoString bstrSourceURL, TAutoString bstrType)
{
	static TAutoDispId _dispId(this, 1204);
	TAutoArgs<2> _args;
	_args[1] = bstrSourceURL;
	_args[2] = bstrType;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPDownloadCollectionProxy::removeItem(long lItem)
{
	static TAutoDispId _dispId(this, 1205);
	TAutoArgs<1> _args;
	_args[1] = lItem;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDownloadCollectionProxy::clear()
{
	static TAutoDispId _dispId(this, 1206);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPDownloadManagerProxy::getDownloadCollection(TIWMPDownloadCollectionProxy& object, long lCollectionId)
{
	static TAutoDispId _dispId(this, 1151);
	TAutoArgs<1> _args;
	_args[1] = lCollectionId;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

void TIWMPDownloadManagerProxy::createDownloadCollection(TIWMPDownloadCollectionProxy& object)
{
	static TAutoDispId _dispId(this, 1152);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acMethod, _args, _dispId, _dispId));
}

TAutoString TIWMPSubscriptionServiceExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPSubscriptionServiceExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPSubscriptionServiceExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPSubscriptionServiceExternalProxy::GetDownloadManager(TIWMPDownloadManagerProxy& object)
{
	static TAutoDispId _dispId(this, 10009);
	TAutoArgs<0> _args;
	object.Bind(Invoke(acPropGet, _args, _dispId, _dispId));
}

TAutoString TIWMPCDDVDWizardExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCDDVDWizardExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorMedium()
{
	static TAutoDispId _dispId(this, 10013);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorDark()
{
	static TAutoDispId _dispId(this, 10014);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorButtonHighlight()
{
	static TAutoDispId _dispId(this, 10015);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorButtonShadow()
{
	static TAutoDispId _dispId(this, 10016);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetappColorButtonHoverFace()
{
	static TAutoDispId _dispId(this, 10017);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPCDDVDWizardExternalProxy::WriteNames(TAutoString bstrTOC, TAutoString bstrMetadata)
{
	static TAutoDispId _dispId(this, 10001);
	TAutoArgs<2> _args;
	_args[1] = bstrTOC;
	_args[2] = bstrMetadata;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCDDVDWizardExternalProxy::ReturnToMainTask()
{
	static TAutoDispId _dispId(this, 10002);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

void TIWMPCDDVDWizardExternalProxy::WriteNamesEx(WMP_WRITENAMESEX_TYPE type, TAutoString bstrTypeId, TAutoString bstrMetadata, bool fRenameRegroupFiles)
{
	static TAutoDispId _dispId(this, 10007);
	TAutoArgs<4> _args;
	_args[1] = type;
	_args[2] = bstrTypeId;
	_args[3] = bstrMetadata;
	_args[4] = fRenameRegroupFiles;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

TAutoString TIWMPCDDVDWizardExternalProxy::GetMDQByRequestID(TAutoString bstrRequestID)
{
	static TAutoDispId _dispId(this, 10008);
	TAutoArgs<1> _args;
	_args[1] = bstrRequestID;
	return Invoke(acMethod, _args, _dispId, _dispId);
}

void TIWMPCDDVDWizardExternalProxy::EditMetadata()
{
	static TAutoDispId _dispId(this, 10011);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

bool TIWMPCDDVDWizardExternalProxy::IsMetadataAvailableForEdit()
{
	static TAutoDispId _dispId(this, 10010);
	TAutoArgs<0> _args;
	return TBool(Invoke(acMethod, _args, _dispId, _dispId));
}

TAutoString TIWMPBaseExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPBaseExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPBaseExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

TAutoString TIWMPOfflineExternalProxy::Getversion()
{
	static TAutoDispId _dispId(this, 10005);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

TAutoString TIWMPOfflineExternalProxy::GetappColorLight()
{
	static TAutoDispId _dispId(this, 10012);
	TAutoArgs<0> _args;
	return Invoke(acPropGet, _args, _dispId, _dispId);
}

void TIWMPOfflineExternalProxy::SetOnColorChange(IDispatch* arg1)
{
	static TAutoDispId _dispId(this, 10018);
	TAutoArgs<0> _args;
	_args[0] = arg1;
	Invoke(acPropSet, _args, _dispId, _dispId);
}

void TIWMPOfflineExternalProxy::forceOnline()
{
	static TAutoDispId _dispId(this, 10025);
	TAutoArgs<0> _args;
	Invoke(acMethod | acVoidRet, _args, _dispId, _dispId);
}

